// D import file generated from 'tango/core/Runtime.d'
module tango.core.Runtime;
debug (TangoRuntime)
{
    private extern (C) int printf(char*,...);


}
private 
{
    extern (C) bool rt_isHalting();

    alias bool function() ModuleUnitTester;
    alias bool function(Object) CollectHandler;
    alias Exception.TraceInfo function(void* ptr = null) TraceHandler;
    extern (C) void rt_setCollectHandler(CollectHandler h);

    extern (C) void rt_setTraceHandler(TraceHandler h);

    alias void delegate(Exception) ExceptionHandler;
    extern (C) bool rt_init(ExceptionHandler dg = null);

    extern (C) bool rt_term(ExceptionHandler dg = null);

    extern (C) void consoleInteger(ulong i);

    extern (C) void consoleString(in char[] str);

}
struct Runtime
{
    struct Console
{
    alias stderr opCall;
    Console stderr(in char[] s)
{
consoleString(s);
return this;
}
    Console stderr(ulong i)
{
consoleInteger(i);
return this;
}
}
    @property static Console console()
{
Console c;
return c;
}


    static bool initialize(void delegate(Exception) dg = null)
{
return rt_init(dg);
}

    static bool terminate(void delegate(Exception) dg = null)
{
return rt_term(dg);
}

    @property static bool isHalting()
{
return rt_isHalting();
}


    @property static void traceHandler(TraceHandler h)
{
rt_setTraceHandler(h);
}


    @property static void collectHandler(CollectHandler h)
{
rt_setCollectHandler(h);
}


    @property static void moduleUnitTester(ModuleUnitTester h)
{
sm_moduleUnitTester = h;
}


    private static ModuleUnitTester sm_moduleUnitTester = null;


}
extern (C) bool runModuleUnitTests();

