// D import file generated from 'tango/core/Signal.d'
module tango.core.Signal;
private import tango.core.Array;

template Signal(Args...)
{
struct Signal
{
    alias void delegate(Args) SlotDg;
    alias void function(Args) SlotFn;
    alias opCall call;
    void opCall(Args args)
{
synchronized {
m_blk = true;
{
for (size_t i = 0;
 i < m_dgs.length; ++i)
{
{
if (m_dgs[i] !is null)
m_dgs[i](args);
}
}
}
m_dgs.length = m_dgs.remove(cast(SlotDg)null);
{
for (size_t i = 0;
 i < m_fns.length; ++i)
{
{
if (m_fns[i] !is null)
m_fns[i](args);
}
}
}
m_fns.length = m_fns.remove(cast(SlotFn)null);
m_blk = false;
procAdds();
}
}
    void attach(SlotDg dg)
{
synchronized {
if (m_blk)
{
m_add ~= Add(dg);
}
else
{
auto pos = m_dgs.find(dg);
if (pos == m_dgs.length)
m_dgs ~= dg;
}
}
}
    void attach(SlotFn fn)
{
synchronized {
if (m_blk)
{
m_add ~= Add(fn);
}
else
{
auto pos = m_fns.find(fn);
if (pos == m_fns.length)
m_fns ~= fn;
}
}
}
    void detach(SlotDg dg)
{
synchronized {
auto pos = m_dgs.find(dg);
if (pos < m_dgs.length)
m_dgs[pos] = null;
}
}
    void detach(SlotFn fn)
{
synchronized {
auto pos = m_fns.find(fn);
if (pos < m_fns.length)
m_fns[pos] = null;
}
}
    private 
{
    struct Add
{
    enum Type 
{
DG,
FN,
}
    static Add opCall(SlotDg d)
{
Add e;
e.ty = Type.DG;
e.dg = d;
return e;
}

    static Add opCall(SlotFn f)
{
Add e;
e.ty = Type.FN;
e.fn = f;
return e;
}

    union
{
SlotDg dg;
SlotFn fn;
}
    Type ty;
}
    void procAdds()
{
foreach (a; m_add)
{
if (a.ty == Add.Type.DG)
m_dgs ~= a.dg;
else
m_fns ~= a.fn;
}
m_add.length = 0;
}
    SlotDg[] m_dgs;
    SlotFn[] m_fns;
    Add[] m_add;
    bool m_blk;
}
}
}
debug (UnitTest)
{
    }
