// D import file generated from 'tango/core/sync/Config.d'
module tango.core.sync.Config;
public import tango.core.Exception;

version (Posix)
{
    private import tango.stdc.posix.time;

    private import tango.stdc.posix.sys.time;

    void getTimespec(ref timespec t);
    void adjTimespec(ref timespec t, double v)
{
enum 
{
SECS_TO_NANOS = 1000000000,
}
v += 1e-10;
if (t.tv_sec.max - t.tv_sec < v)
{
t.tv_sec = t.tv_sec.max;
t.tv_nsec = 0;
}
else
{
alias typeof(t.tv_sec) Secs;
alias typeof(t.tv_nsec) Nanos;
t.tv_sec += cast(Secs)v;
auto ns = cast(long)(v % 1 * SECS_TO_NANOS);
if (SECS_TO_NANOS - t.tv_nsec <= ns)
{
t.tv_sec += 1;
ns -= SECS_TO_NANOS;
}
t.tv_nsec += cast(Nanos)ns;
}
}
}
