// D import file generated from 'tango/io/selector/SelectorException.d'
module tango.io.selector.SelectorException;
public class SelectorException : Exception
{
    public this(string msg, string file, size_t line)
{
super(msg,file,line);
}

}

public class UnregisteredConduitException : SelectorException
{
    public this(string file, size_t line)
{
super("The conduit is not registered to the selector",file,line);
}

}

public class RegisteredConduitException : SelectorException
{
    public this(string file, size_t line)
{
super("The conduit is already registered to the selector",file,line);
}

}

public class InterruptedSystemCallException : SelectorException
{
    public this(string file, size_t line)
{
super("A system call was interrupted by a signal",file,line);
}

}

public class OutOfMemoryException : SelectorException
{
    public this(string file, size_t line)
{
super("Out of memory",file,line);
}

}

