// D import file generated from 'tango/io/stream/DataFile.d'
module tango.io.stream.DataFile;
private import tango.io.device.File;

private import tango.io.stream.Data;

class DataFileInput : DataInput
{
    private File conduit;

    this(char[] path, File.Style style = File.ReadExisting)
{
this(new File(path,style));
}
    this(File file)
{
super(conduit = file);
}
    final File file()
{
return conduit;
}

}
class DataFileOutput : DataOutput
{
    private File conduit;

    this(char[] path, File.Style style = File.WriteCreate)
{
this(new File(path,style));
}
    this(File file)
{
super(conduit = file);
}
    final File file()
{
return conduit;
}

}
debug (DataFile)
{
    import tango.io.Stdout;
    void main()
{
auto myFile = new DataFileOutput("Hello.txt");
myFile.write("some text");
myFile.flush;
Stdout.formatln("{}:{}",myFile.file.position,myFile.seek(myFile.Anchor.Current));
}
}
