// D import file generated from 'tango/io/stream/Patterns.d'
module tango.io.stream.Patterns;
private import tango.text.Regex;

private import tango.io.stream.Iterator;

class Patterns : Iterator!(char)
{
    private Regex regex;

    private alias char T;

    this(const(T)[] pattern, InputStream stream = null)
{
regex = new Regex(pattern,"");
super(stream);
}
    protected override size_t scan(const(void)[] data)
{
auto content = (cast(const(T)*)data.ptr)[0..data.length / T.sizeof];
if (regex.test(content))
{
int start = regex.registers_[0];
int finish = regex.registers_[1];
set(content.ptr,0,start);
return found(finish - 1);
}
return notFound();
}


}
debug (UnitTest)
{
    private import tango.io.device.Array;

    }
