// D import file generated from 'tango/io/stream/Quotes.d'
module tango.io.stream.Quotes;
private import tango.io.stream.Iterator;

template Quotes(T)
{
class Quotes : Iterator!(T)
{
    private const(T)[] delim;

    this(const(T)[] delim, InputStream stream = null)
{
super(stream);
this.delim = delim;
}
    protected override size_t scan(const(void)[] data)
{
T quote = 0;
int escape = 0;
auto content = (cast(const(T)*)data.ptr)[0..data.length / T.sizeof];
foreach (i, c; content)
{
if (quote)
{
if (c is '\x5c')
++escape;
else
{
if (c is quote && escape % 2 is 0)
quote = 0;
escape = 0;
}
}
else
if (c is '"' || c is '\'')
quote = c;
else
if (has(delim,c))
return found(set(content.ptr,0,i));
}
return notFound();
}


}
}
debug (UnitTest)
{
    private import tango.io.Stdout;

    private import tango.text.Util;

    private import tango.io.device.Array;

    }
