// D import file generated from 'tango/io/vfs/LinkedFolder.d'
module tango.io.vfs.LinkedFolder;
private import tango.io.vfs.model.Vfs;

private import tango.core.Exception;

private import tango.io.vfs.VirtualFolder;

class LinkedFolder : VirtualFolder
{
    private Link* head;

    private struct Link
{
    Link* next;
    VfsFolder folder;
    static Link* opCall(VfsFolder folder)
{
auto p = new Link;
p.folder = folder;
return p;
}

}

    this(const(char)[] name)
{
super(name);
}
    final override VfsHost mount(VfsFolder folder, const(char)[] name = null);

    final override VfsHost dismount(VfsFolder folder)
{
assert(0,"LinkedFolder.dismount not implemented");
}

    final override @property VfsFile file(const(char)[] path);

}
debug (LinkedFolder)
{
    import tango.io.Stdout;
    import tango.io.vfs.FileFolder;
    void main()
{
auto root = new LinkedFolder("root");
auto sub = new VirtualFolder("sub");
sub.mount(new FileFolder("d:/d/import/temp"));
sub.map(sub.file("temp/subtree/test.txt"),"wumpus");
root.mount(new FileFolder("d:/d/import/tango")).mount(new FileFolder("c:/"),"windows");
root.mount(sub);
auto file = root.file("wumpus");
Stdout.formatln("file = {}",file);
}
}
