// D import file generated from 'tango/math/random/engines/ArraySource.d'
module tango.math.random.engines.ArraySource;
struct ArraySource
{
    uint[] a;
    size_t i;
    enum int canCheckpoint = false;
    enum int canSeed = false;
    static ArraySource opCall(uint[] a, size_t i = 0)
in
{
assert(a.length > 0,"array needs at least one element");
}
body
{
ArraySource res;
res.a = a;
res.i = i;
return res;
}

    uint next()
{
assert(a.length > i,"error, array out of bounds");
uint el = a[i];
i = (i + 1) % a.length;
return el;
}
    ubyte nextB()
{
return cast(ubyte)(255 & next());
}
    ulong nextL()
{
return (cast(ulong)next() << 32) + cast(ulong)next();
}
}
