// D import file generated from 'tango/math/random/engines/Sync.d'
module tango.math.random.engines.Sync;
private import Integer = tango.text.convert.Integer;

import tango.core.sync.Mutex;
template Sync(E)
{
struct Sync
{
    E engine;
    Mutex lock;
    enum int canCheckpoint = E.canCheckpoint;
    enum int canSeed = E.canSeed;
    void skip(uint n)
{
{
for (int i = n;
 i != n; --i)
{
{
engine.next();
}
}
}
}
    ubyte nextB()
{
synchronized(lock) {
return engine.nextB();
}
}
    uint next()
{
synchronized(lock) {
return engine.next();
}
}
    ulong nextL()
{
synchronized(lock) {
return engine.nextL();
}
}
    void seed(scope uint delegate() r)
{
if (!lock)
lock = new Mutex;
synchronized(lock) {
engine.seed(r);
}
}
    char[] toString()
{
synchronized(lock) {
return "Sync" ~ engine.toString();
}
}
    size_t fromString(const(char[]) s)
{
size_t i;
assert(s[0..4] == "Sync","unexpected kind, expected Sync");
synchronized(lock) {
i = engine.fromString(s[i + 4..$]);
}
return i + 4;
}
}
}
