// D import file generated from 'tango/net/http/HttpHeaders.d'
module tango.net.http.HttpHeaders;
private import tango.time.Time;

private import tango.io.stream.Lines;

private import tango.io.model.IConduit;

public import tango.net.http.HttpConst;

private import tango.net.http.HttpTokens;

struct HeaderElement
{
    HttpHeaderName name;
    const(char)[] value;
}
class HttpHeadersView : HttpTokens
{
    alias HttpTokens.parse parse;
    private Lines!(char) line;

    private bool preserve;

    this()
{
super(':',true);
line = new Lines!(char);
}
    this(HttpHeadersView source)
{
super(source);
this.preserve = source.preserve;
}
    HttpHeadersView clone()
{
return new HttpHeadersView(this);
}
    HttpHeadersView retain(bool yes = true)
{
preserve = yes;
return this;
}
    override void parse(InputBuffer input);

    char[] get(HttpHeaderName name, const(char)[] def = null)
{
return super.get(name.value,def);
}
    int getInt(const(HttpHeaderName) name, int def = -1)
{
return super.getInt(name.value,def);
}
    Time getDate(HttpHeaderName name, Time def = Time.epoch)
{
return super.getDate(name.value,def);
}
    int opApply(scope int delegate(ref HeaderElement) dg);
    FilteredHeaders createFilter(HttpHeaderName header)
{
return new FilteredHeaders(this,header);
}
    private static class FilteredHeaders : FilteredTokens
{
    this(HttpHeadersView headers, HttpHeaderName header)
{
super(headers,header.value);
}
    int opApply(scope int delegate(ref HeaderElement) dg);
}


}
class HttpHeaders : HttpHeadersView
{
    this()
{
}
    this(HttpHeaders source)
{
super(source);
}
    override HttpHeaders clone()
{
return new HttpHeaders(this);
}

    void add(HttpHeaderName name, scope void delegate(OutputBuffer) dg)
{
super.add(name.value,dg);
}
    void add(HttpHeaderName name, const(char)[] value)
{
super.add(name.value,value);
}
    void addInt(HttpHeaderName name, size_t value)
{
super.addInt(name.value,value);
}
    void addDate(HttpHeaderName name, Time value)
{
super.addDate(name.value,value);
}
    bool remove(HttpHeaderName name)
{
return super.remove(name.value);
}
}
