// D import file generated from 'tango/stdc/posix/fcntl.d'
module tango.stdc.posix.fcntl;
private import tango.stdc.posix.config;

private import tango.stdc.stdint;

public import tango.stdc.stddef;

public import tango.stdc.posix.sys.types;

public import tango.stdc.posix.sys.stat;

public import tango.sys.consts.fcntl;

extern (C) 
{
    version (linux)
{
    struct flock
{
    short l_type;
    short l_whence;
    off_t l_start;
    off_t l_len;
    pid_t l_pid;
}
    static if(__USE_LARGEFILE64)
{
    int creat64(in char*, mode_t);
    alias creat64 creat;
    int open64(in char*, int,...);
    alias open64 open;
}
else
{
    int creat(in char*, mode_t);
    int open(in char*, int,...);
}
}
else
{
    version (darwin)
{
    struct flock
{
    off_t l_start;
    off_t l_len;
    pid_t l_pid;
    short l_type;
    short l_whence;
}
    int creat(in char*, mode_t);
    int open(in char*, int,...);
}
else
{
    version (freebsd)
{
    struct flock
{
    off_t l_start;
    off_t l_len;
    pid_t l_pid;
    short l_type;
    short l_whence;
}
    int creat(in char*, mode_t);
    int open(in char*, int,...);
}
else
{
    version (solaris)
{
    struct flock
{
    short l_type;
    short l_whence;
    off_t l_start;
    off_t l_len;
    int l_sysid;
    pid_t l_pid;
    c_long[4] l_pad;
}
    int creat(in char*, mode_t);
    int open(in char*, int,...);
    static if(__USE_LARGEFILE64)
{
    alias creat creat64;
    alias open open64;
}
}
}
}
}
    int fcntl(int, int,...);
}
