// D import file generated from 'tango/stdc/posix/poll.d'
module tango.stdc.posix.poll;
private import tango.stdc.posix.config;

extern (C) version (linux)
{
    struct pollfd
{
    int fd;
    short events;
    short revents;
}
    alias c_ulong nfds_t;
    const POLLIN = 1;
    const POLLRDNORM = 64;
    const POLLRDBAND = 128;
    const POLLPRI = 2;
    const POLLOUT = 4;
    const POLLWRNORM = 256;
    const POLLWRBAND = 512;
    const POLLERR = 8;
    const POLLHUP = 16;
    const POLLNVAL = 32;
    int poll(pollfd*, nfds_t, int);
}
else
{
    version (darwin)
{
    struct pollfd
{
    int fd;
    short events;
    short revents;
}
    alias uint nfds_t;
    enum 
{
POLLIN = 1,
POLLPRI = 2,
POLLOUT = 4,
POLLRDNORM = 64,
POLLWRNORM = POLLOUT,
POLLRDBAND = 128,
POLLWRBAND = 256,
POLLEXTEND = 512,
POLLATTRIB = 1024,
POLLNLINK = 2048,
POLLWRITE = 4096,
POLLERR = 8,
POLLHUP = 16,
POLLNVAL = 32,
POLLSTANDARD = POLLIN | POLLPRI | POLLOUT | POLLRDNORM | POLLRDBAND | POLLWRBAND | POLLERR | POLLHUP | POLLNVAL,
}
    int poll(pollfd*, nfds_t, int);
}
else
{
    version (freebsd)
{
    struct pollfd
{
    int fd;
    short events;
    short revents;
}
    alias uint nfds_t;
    enum 
{
POLLIN = 1,
POLLPRI = 2,
POLLOUT = 4,
POLLRDNORM = 64,
POLLWRNORM = POLLOUT,
POLLRDBAND = 128,
POLLWRBAND = 256,
POLLERR = 8,
POLLHUP = 16,
POLLNVAL = 32,
POLLSTANDARD = POLLIN | POLLPRI | POLLOUT | POLLRDNORM | POLLRDBAND | POLLWRBAND | POLLERR | POLLHUP | POLLNVAL,
}
    int poll(pollfd*, nfds_t, int);
}
else
{
    version (solaris)
{
    private import tango.stdc.config;

    struct pollfd
{
    int fd;
    short events;
    short revents;
}
    alias c_ulong nfds_t;
    enum 
{
POLLIN = 1,
POLLPRI = 2,
POLLOUT = 4,
POLLRDNORM = 64,
POLLWRNORM = POLLOUT,
POLLRDBAND = 128,
POLLWRBAND = 256,
POLLERR = 8,
POLLHUP = 16,
POLLNVAL = 32,
POLLSTANDARD = POLLIN | POLLPRI | POLLOUT | POLLRDNORM | POLLRDBAND | POLLWRBAND | POLLERR | POLLHUP | POLLNVAL,
}
    int poll(pollfd*, nfds_t, int);
}
}
}
}

