// D import file generated from 'tango/stdc/posix/sys/shm.d'
module tango.stdc.posix.sys.shm;
private import tango.stdc.posix.config;

public import tango.stdc.posix.sys.types;

public import tango.stdc.posix.sys.ipc;

private import tango.core.Octal;

extern (C) version (linux)
{
    const SHM_RDONLY = octal!(10000);
    const SHM_RND = octal!(20000);
    int __getpagesize();
    alias __getpagesize SHMLBA;
    alias c_ulong shmatt_t;
    struct shmid_ds
{
    ipc_perm shm_perm;
    size_t shm_segsz;
    time_t shm_atime;
    c_ulong __unused1;
    time_t shm_dtime;
    c_ulong __unused2;
    time_t shm_ctime;
    c_ulong __unused3;
    pid_t shm_cpid;
    pid_t shm_lpid;
    shmatt_t shm_nattch;
    c_ulong __unused4;
    c_ulong __unused5;
}
    void* shmat(int, in void*, int);
    int shmctl(int, int, shmid_ds*);
    int shmdt(in void*);
    int shmget(key_t, size_t, int);
}
else
{
    version (freebsd)
{
    const SHM_RDONLY = octal!(10000);
    const SHM_RND = octal!(20000);
    const SHMLBA = 1 << 12;
    alias c_ulong shmatt_t;
    struct shmid_ds
{
    ipc_perm shm_perm;
    size_t shm_segsz;
    time_t shm_atime;
    c_ulong __unused1;
    time_t shm_dtime;
    c_ulong __unused2;
    time_t shm_ctime;
    c_ulong __unused3;
    pid_t shm_cpid;
    pid_t shm_lpid;
    shmatt_t shm_nattch;
    c_ulong __unused4;
    c_ulong __unused5;
}
    void* shmat(int, in void*, int);
    int shmctl(int, int, shmid_ds*);
    int shmdt(in void*);
    int shmget(key_t, size_t, int);
}
else
{
    version (darwin)
{
}
else
{
    version (solaris)
{
    private const _SC_PAGESIZE = 11;

    private c_long _sysconf(int);

    const SHM_RDONLY = octal!(10000);
    const SHM_RND = octal!(20000);
    const SHM_SHARE_MMU = octal!(40000);
    const SHM_PAGEABLE = octal!(100000);
    extern (D) c_long SHMLBA()
{
return _sysconf(_SC_PAGESIZE);
}

    alias c_ulong shmatt_t;
    struct shmid_ds
{
    ipc_perm shm_perm;
    size_t shm_segsz;
    void* shm_amp;
    ushort shm_lkcnt;
    pid_t shm_lpid;
    pid_t shm_cpid;
    shmatt_t shm_nattch;
    ulong shm_cnattch;
    version (X86_64)
{
    time_t shm_atime;
    time_t shm_dtime;
    time_t shm_ctime;
    long[4] shm_pad4;
}
else
{
    time_t shm_atime;
    int shm_pad1;
    time_t shm_dtime;
    int shm_pad2;
    time_t shm_ctime;
    int shm_pad3;
    int[4] shm_pad4;
}
}
    void* shmat(int, in void*, int);
    int shmctl(int, int, shmid_ds*);
    int shmdt(in void*);
    int shmget(key_t, size_t, int);
}
}
}
}

