// D import file generated from 'tango/stdc/posix/sys/statvfs.d'
module tango.stdc.posix.sys.statvfs;
import tango.stdc.config;
version (darwin)
{
    struct statvfs_t
{
    c_ulong f_bsize;
    c_ulong f_frsize;
    uint f_blocks;
    uint f_bfree;
    uint f_bavail;
    uint f_files;
    uint f_ffree;
    uint f_favail;
    c_ulong f_fsid;
    c_ulong f_flag;
    c_ulong f_namemax;
}
    enum 
{
ST_RDONLY = 1,
ST_NOSUID = 2,
}
}
version (freebsd)
{
    alias ulong __fsblkcnt_t;
    alias ulong __fsfilcnt_t;
    struct statvfs_t
{
    __fsblkcnt_t f_bavail;
    __fsblkcnt_t f_bfree;
    __fsblkcnt_t f_blocks;
    __fsfilcnt_t f_favail;
    __fsfilcnt_t f_ffree;
    __fsfilcnt_t f_files;
    c_ulong f_bsize;
    c_ulong f_flag;
    c_ulong f_frsize;
    c_ulong f_fsid;
    c_ulong f_namemax;
}
    enum 
{
ST_RDONLY = 1,
ST_NOSUID = 2,
}
}
version (linux)
{
    struct statvfs_t
{
    c_ulong f_bsize;
    c_ulong f_frsize;
    c_ulong f_blocks;
    c_ulong f_bfree;
    c_ulong f_bavail;
    c_ulong f_files;
    c_ulong f_ffree;
    c_ulong f_favail;
    c_ulong f_fsid;
    c_ulong f_flag;
    c_ulong f_namemax;
    int[6] __f_spare;
}
    enum 
{
ST_RDONLY = 1,
ST_NOSUID = 2,
}
}
version (solaris)
{
    const _FSTYPSZ = 16;
    alias c_ulong fsblkcnt_t;
    alias c_ulong fsfilcnt_t;
    struct statvfs_t
{
    c_ulong f_bsize;
    c_ulong f_frsize;
    fsblkcnt_t f_blocks;
    fsblkcnt_t f_bfree;
    fsblkcnt_t f_bavail;
    fsfilcnt_t f_files;
    fsfilcnt_t f_ffree;
    fsfilcnt_t f_favail;
    c_ulong f_fsid;
    char[_FSTYPSZ] f_basetype;
    c_ulong f_flag;
    c_ulong f_namemax;
    char[32] f_fstr;
    static if(size_t.sizeof == 8)
{
    c_ulong[16] f_filler;
}
}
    enum 
{
ST_RDONLY = 1,
ST_NOSUID = 2,
}
}
extern (C) 
{
    int fstatvfs(int, statvfs_t*);
    int statvfs(in char*, statvfs_t*);
}
