// D import file generated from 'tango/stdc/posix/sys/time.d'
module tango.stdc.posix.sys.time;
private import tango.stdc.posix.config;

public import tango.stdc.posix.sys.types;

public import tango.stdc.posix.sys.select;

extern (C) version (linux)
{
    struct timeval
{
    time_t tv_sec;
    suseconds_t tv_usec;
}
    struct itimerval
{
    timeval it_interval;
    timeval it_value;
}
    const ITIMER_REAL = 0;
    const ITIMER_VIRTUAL = 1;
    const ITIMER_PROF = 2;
    int getitimer(int, itimerval*);
    int gettimeofday(timeval*, void*);
    int select(int, fd_set*, fd_set*, fd_set*, timeval*);
    int setitimer(int, in itimerval*, itimerval*);
    int utimes(in char*, in timeval[2]);
}
else
{
    version (darwin)
{
    struct timeval
{
    time_t tv_sec;
    suseconds_t tv_usec;
}
    struct itimerval
{
    timeval it_interval;
    timeval it_value;
}
    struct timezone_t
{
    int tz_minuteswest;
    int tz_dsttime;
}
    int getitimer(int, itimerval*);
    int gettimeofday(timeval*, timezone_t*);
    int select(int, fd_set*, fd_set*, fd_set*, timeval*);
    int setitimer(int, in itimerval*, itimerval*);
    int utimes(in char*, in timeval[2]);
}
else
{
    version (freebsd)
{
    struct timeval
{
    time_t tv_sec;
    suseconds_t tv_usec;
}
    struct itimerval
{
    timeval it_interval;
    timeval it_value;
}
    struct timezone_t
{
    int tz_minuteswest;
    int tz_dsttime;
}
    int getitimer(int, itimerval*);
    int gettimeofday(timeval*, timezone_t*);
    int select(int, fd_set*, fd_set*, fd_set*, timeval*);
    int setitimer(int, in itimerval*, itimerval*);
    int utimes(in char*, in timeval[2]);
}
else
{
    version (solaris)
{
    struct timeval
{
    time_t tv_sec;
    suseconds_t tv_usec;
}
    struct itimerval
{
    timeval it_interval;
    timeval it_value;
}
    struct timezone_t
{
    int tz_minuteswest;
    int tz_dsttime;
}
    int getitimer(int, itimerval*);
    int gettimeofday(timeval*, timezone_t*);
    int select(int, fd_set*, fd_set*, fd_set*, timeval*);
    int setitimer(int, in itimerval*, itimerval*);
    int utimes(in char*, in timeval*);
}
}
}
}

