// D import file generated from 'tango/stdc/posix/sys/utsname.d'
module tango.stdc.posix.sys.utsname;
extern (C) 
{
    version (darwin)
{
    private const size_t len = 256;


    struct utsname
{
    char[len] sysname;
    char[len] nodename;
    char[len] release;
    char[len] version_;
    char[len] machine;
}
}
else
{
    version (freebsd)
{
    private const size_t len = 256;


    struct utsname
{
    char[len] sysname;
    char[len] nodename;
    char[len] release;
    char[len] version_;
    char[len] machine;
}
}
else
{
    version (linux)
{
    private const size_t len = 65;


    struct utsname
{
    char[len] sysname;
    char[len] nodename;
    char[len] release;
    char[len] version_;
    char[len] machine;
    char[len] domainname;
}
}
else
{
    version (solaris)
{
    private const size_t len = 257;


    struct utsname
{
    char[len] sysname;
    char[len] nodename;
    char[len] release;
    char[len] version_;
    char[len] machine;
}
}
else
{
    static assert(false,"utsname is not available on this platform");
}
}
}
}
    int uname(utsname*);
}
