// D import file generated from 'tango/sys/linux/epoll.d'
module tango.sys.linux.epoll;
version (linux)
{
    extern (C) 
{
    enum : uint
{
EPOLLIN = 1,
EPOLLPRI = 2,
EPOLLOUT = 4,
EPOLLRDNORM = 64,
EPOLLRDBAND = 128,
EPOLLWRNORM = 256,
EPOLLWRBAND = 512,
EPOLLMSG = 1024,
EPOLLERR = 8,
EPOLLHUP = 16,
EPOLLONESHOT = 1 << 30,
EPOLLET = 1 << 31,
}
    public const int EPOLL_CTL_ADD = 1;


    public const int EPOLL_CTL_DEL = 2;


    public const int EPOLL_CTL_MOD = 3;


    align (1)union epoll_data
{
    void* ptr;
    int fd;
    uint u32;
    ulong u64;
}

    alias epoll_data epoll_data_t;
    align (1)struct epoll_event
{
    uint events;
    epoll_data_t data;
}

    int epoll_create(int size);
    int epoll_ctl(int epfd, int op, int fd, epoll_event* event);
    int epoll_wait(int epfd, epoll_event* events, int maxevents, int timeout);
}
}
