// D import file generated from 'tango/util/compress/c/zlib.d'
module tango.util.compress.c.zlib;
extern (C) 
{
    enum immutable(char)* ZLIB_VERSION = "1.2.3".ptr;
    enum uint ZLIB_VERNUM = 4656;
    private 
{
    import tango.stdc.config;
    version (Posix)
{
    import tango.stdc.posix.sys.types;
}
else
{
    alias c_long z_off_t;
}
    alias ubyte Byte;
    alias uint uInt;
    alias c_ulong uLong;
    alias Byte Bytef;
    alias char charf;
    alias int intf;
    alias uInt uIntf;
    alias uLong uLongf;
    alias void* voidpc;
    alias void* voidpf;
    alias void* voidp;
    alias voidpf function(voidpf opaque, uInt items, uInt size) alloc_func;
    alias void function(voidpf opaque, voidpf address) free_func;
    struct internal_state
{
}
}
    struct z_stream
{
    Bytef* next_in;
    uInt avail_in;
    uLong total_in;
    Bytef* next_out;
    uInt avail_out;
    uLong total_out;
    char* msg;
    internal_state* state;
    alloc_func zalloc;
    free_func zfree;
    voidpf opaque;
    int data_type;
    uLong adler;
    uLong reserved;
}
    alias z_stream* z_streamp;
    struct gz_header
{
    int text;
    uLong time;
    int xflags;
    int os;
    Bytef* extra;
    uInt extra_len;
    uInt extra_max;
    Bytef* name;
    uInt name_max;
    Bytef* comment;
    uInt comm_max;
    int hcrc;
    int done;
}
    alias gz_header* gz_headerp;
    enum 
{
Z_NO_FLUSH = 0,
Z_PARTIAL_FLUSH = 1,
Z_SYNC_FLUSH = 2,
Z_FULL_FLUSH = 3,
Z_FINISH = 4,
Z_BLOCK = 5,
}
    enum 
{
Z_OK = 0,
Z_STREAM_END = 1,
Z_NEED_DICT = 2,
Z_ERRNO = -1,
Z_STREAM_ERROR = -2,
Z_DATA_ERROR = -3,
Z_MEM_ERROR = -4,
Z_BUF_ERROR = -5,
Z_VERSION_ERROR = -6,
}
    enum 
{
Z_NO_COMPRESSION = 0,
Z_BEST_SPEED = 1,
Z_BEST_COMPRESSION = 9,
Z_DEFAULT_COMPRESSION = -1,
}
    enum 
{
Z_FILTERED = 1,
Z_HUFFMAN_ONLY = 2,
Z_RLE = 3,
Z_FIXED = 4,
Z_DEFAULT_STRATEGY = 0,
}
    enum 
{
Z_BINARY = 0,
Z_TEXT = 1,
Z_ASCII = Z_TEXT,
Z_UNKNOWN = 2,
}
    enum 
{
Z_DEFLATED = 8,
}
    enum Z_NULL = null;
    alias zlibVersion zlib_version;
    const(char)* zlibVersion();
    int deflate(z_streamp strm, int flush);
    int deflateEnd(z_streamp strm);
    int inflate(z_streamp strm, int flush);
    int inflateEnd(z_streamp strm);
    int deflateSetDictionary(z_streamp strm, Bytef* dictionary, uInt dictLength);
    int deflateCopy(z_streamp dest, z_streamp source);
    int deflateReset(z_streamp strm);
    int deflateParams(z_streamp strm, int level, int strategy);
    int deflateTune(z_streamp strm, int good_length, int max_lazy, int nice_length, int max_chain);
    uLong deflateBound(z_streamp strm, uLong sourceLen);
    int deflatePrime(z_streamp strm, int bits, int value);
    int deflateSetHeader(z_streamp strm, gz_headerp head);
    int inflateSetDictionary(z_streamp strm, Bytef* dictionary, uInt dictLength);
    int inflateSync(z_streamp strm);
    int inflateCopy(z_streamp dest, z_streamp source);
    int inflateReset(z_streamp strm);
    int inflatePrime(z_streamp strm, int bits, int value);
    int inflateGetHeader(z_streamp strm, gz_headerp head);
    alias uint function(void*, ubyte**) in_func;
    alias int function(void*, ubyte*, uint) out_func;
    int inflateBack(z_streamp strm, in_func in_fn, void* in_desc, out_func out_fn, void* out_desc);
    int inflateBackEnd(z_streamp strm);
    uLong zlibCompileFlags();
    int compress(Bytef* dest, uLongf* destLen, Bytef* source, uLong sourceLen);
    int compress2(Bytef* dest, uLongf* destLen, Bytef* source, uLong sourceLen, int level);
    uLong compressBound(uLong sourceLen);
    int uncompress(Bytef* dest, uLongf* destLen, Bytef* source, uLong sourceLen);
    alias voidp gzFile;
    gzFile gzopen(char* path, char* mode);
    gzFile gzdopen(int fd, char* mode);
    int gzsetparams(gzFile file, int level, int strategy);
    int gzread(gzFile file, voidp buf, uint len);
    int gzwrite(gzFile file, voidpc buf, uint len);
    int gzprintf(gzFile file, const(char)* format,...);
    int gzputs(gzFile file, const(char)* s);
    char* gzgets(gzFile file, char* buf, int len);
    int gzputc(gzFile file, int c);
    int gzgetc(gzFile file);
    int gzungetc(int c, gzFile file);
    int gzflush(gzFile file, int flush);
    z_off_t gzseek(gzFile file, z_off_t offset, int whence);
    int gzrewind(gzFile file);
    z_off_t gztell(gzFile file);
    int gzeof(gzFile file);
    int gzdirect(gzFile file);
    int gzclose(gzFile file);
    const(char)* gzerror(gzFile file, int* errnum);
    void gzclearerr(gzFile file);
    uLong adler32(uLong adler, Bytef* buf, uInt len);
    uLong adler32_combine(uLong adler1, uLong adler2, z_off_t len2);
    uLong crc32(uLong crc, Bytef* buf, uInt len);
    uLong crc32_combine(uLong crc1, uLong crc2, z_off_t len2);
    int deflateInit_(z_streamp strm, int level, const(char)* ver, int stream_size);
    int inflateInit_(z_streamp strm, const(char)* ver, int stream_size);
    int deflateInit2_(z_streamp strm, int level, int method, int windowBits, int memLevel, int strategy, const(char)* ver, int stream_size);
    int inflateInit2_(z_streamp strm, int windowBits, const(char)* ver, int stream_size);
    int inflateBackInit_(z_streamp strm, int windowBits, ubyte* window, const(char)* ver, int stream_size);
    extern (D) int deflateInit(z_streamp strm, int level)
{
return deflateInit_(strm,level,ZLIB_VERSION,z_stream.sizeof);
}

    extern (D) int inflateInit(z_streamp strm)
{
return inflateInit_(strm,ZLIB_VERSION,z_stream.sizeof);
}

    extern (D) int deflateInit2(z_streamp strm, int level, int method, int windowBits, int memLevel, int strategy)
{
return deflateInit2_(strm,level,method,windowBits,memLevel,strategy,ZLIB_VERSION,z_stream.sizeof);
}

    extern (D) int inflateInit2(z_streamp strm, int windowBits)
{
return inflateInit2_(strm,windowBits,ZLIB_VERSION,z_stream.sizeof);
}

    extern (D) int inflateBackInit(z_streamp strm, int windowBits, ubyte* window)
{
return inflateBackInit_(strm,windowBits,window,ZLIB_VERSION,z_stream.sizeof);
}

    const(char)* zError(int);
    int inflateSyncPoint(z_streamp z);
    uLongf* get_crc_table();
}
