// D import file generated from 'tango/util/container/model/IContainer.d'
module tango.util.container.model.IContainer;
template IContainer(V)
{
interface IContainer
{
    const size_t size();

    const bool isEmpty();

    IContainer dup();
    IContainer clear();
    IContainer reset();
    IContainer check();
    bool contains(V value);
    bool take(ref V element);
    V[] toArray(V[] dst = null);
    size_t remove(V element, bool all);
    int opApply(scope int delegate(ref V value) dg);
    size_t replace(V oldElement, V newElement, bool all);
}
}
template Compare(V)
{
alias int function(ref V a, ref V b) Compare;
}
