// D import file generated from 'tango/util/digest/Md5.d'
module tango.util.digest.Md5;
public import tango.util.digest.Md4;

private import tango.util.digest.MerkleDamgard;

final class Md5 : Md4
{
    private enum 
{
S11 = 7,
S12 = 12,
S13 = 17,
S14 = 22,
S21 = 5,
S22 = 9,
S23 = 14,
S24 = 20,
S31 = 4,
S32 = 11,
S33 = 16,
S34 = 23,
S41 = 6,
S42 = 10,
S43 = 15,
S44 = 21,
}

    this()
{
}
    protected override void transform(const(ubyte[]) input);


    private static uint g(uint x, uint y, uint z)
{
return x & z | y & ~z;
}


    private static uint i(uint x, uint y, uint z)
{
return y ^ (x | ~z);
}


    private static void ff(ref uint a, uint b, uint c, uint d, uint x, uint s, uint ac)
{
a += f(b,c,d) + x + ac;
a = rotateLeft(a,s);
a += b;
}


    private static void gg(ref uint a, uint b, uint c, uint d, uint x, uint s, uint ac)
{
a += g(b,c,d) + x + ac;
a = rotateLeft(a,s);
a += b;
}


    private static void hh(ref uint a, uint b, uint c, uint d, uint x, uint s, uint ac)
{
a += h(b,c,d) + x + ac;
a = rotateLeft(a,s);
a += b;
}


    private static void ii(ref uint a, uint b, uint c, uint d, uint x, uint s, uint ac)
{
a += i(b,c,d) + x + ac;
a = rotateLeft(a,s);
a += b;
}


}

debug (UnitTest)
{
    }
