// D import file generated from 'tango/util/digest/Sha1.d'
module tango.util.digest.Sha1;
private import tango.util.digest.Sha01;

public import tango.util.digest.Digest;

final class Sha1 : Sha01
{
    this()
{
}
    final protected override void transform(const(ubyte[]) input)
{
uint A,B,C,D,E,TEMP;
uint[16] W;
uint s;
bigEndian32(input,W);
A = context[0];
B = context[1];
C = context[2];
D = context[3];
E = context[4];
{
for (uint t = 0;
 t < 80; t++)
{
{
s = t & mask;
if (t >= 16)
expand(W,s);
TEMP = rotateLeft(A,5) + f(t,B,C,D) + E + W[s] + K[t / 20];
E = D;
D = C;
C = rotateLeft(B,30);
B = A;
A = TEMP;
}
}
}
context[0] += A;
context[1] += B;
context[2] += C;
context[3] += D;
context[4] += E;
}



    final static void expand(uint[] W, uint s)
{
W[s] = rotateLeft(W[s + 13 & mask] ^ W[s + 8 & mask] ^ W[s + 2 & mask] ^ W[s],1);
}


}

debug (UnitTest)
{
    }
