// D import file generated from 'tango/util/log/AppendSyslog.d'
module tango.util.log.AppendSyslog;
private import tango.time.Time;

private 
{
    import Path = tango.io.Path;
    import tango.io.device.File;
    import tango.io.FilePath;
}
private import tango.io.model.IFile;

private 
{
    import tango.util.log.Log;
    import tango.util.log.AppendFile;
}
private import Integer = tango.text.convert.Integer;

private import tango.text.convert.Format;

private import tango.util.MinMax;

private import tango.sys.Process;

public class AppendSyslog : Filer
{
    private Mask mask_;

    private 
{
    long max_size;
    long file_size;
    long max_files;
    long compress_index;
}
    private FilePath file_path;

    private char[] path;

    private char[] compress_suffix;

    private Process compress_cmd;

    this(char[] path, uint count, long max_size, char[] compress_cmd = null, char[] compress_suffix = null, size_t compress_begin = 2, Appender.Layout how = null)
{
assert(path);
assert(count < 1000);
assert(compress_begin >= 2);
mask_ = register(path);
auto style = File.WriteAppending;
style.share = File.Share.Read;
auto conduit = new File(path,style);
configure(conduit);
this.max_size = max_size;
this.file_size = conduit.length;
this.max_files = count;
layout(how);
this.file_path = new FilePath(path);
this.file_path.pop();
this.path = path.dup;
char[512] buf,buf1;
auto compr_path = Format.sprint(buf,"{}.{}",this.path,compress_begin);
auto cmd = Format.sprint(buf1,compress_cmd,compr_path);
this.compress_cmd = new Process(cmd.dup);
this.compress_suffix = "." ~ compress_suffix;
this.compress_index = compress_begin;
}
    final override @property const Mask mask()
{
return mask_;
}

    final override @property const const(char)[] name()
{
return this.classinfo.name;
}

    final override void append(LogEvent event);

    private void openConduit()
{
this.file_size = 0;
auto style = File.WriteAppending;
style.share = File.Share.Read;
(cast(File)this.conduit).open(this.path,style);
}

    private void nextFile();

}

debug (AppendSyslog)
{
    void main()
{
Log.root.add(new AppendFiles("foo",5,6));
auto log = Log.lookup("fu.bar");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
}
}
