// D import file generated from 'tango/util/log/LayoutDate.d'
module tango.util.log.LayoutDate;
private import tango.text.Util;

private 
{
    import tango.time.Clock;
    import tango.time.WallClock;
}
private import tango.util.log.Log;

private import Integer = tango.text.convert.Integer;

public class LayoutDate : Appender.Layout
{
    private bool localTime;

    this(bool localTime = true)
{
this.localTime = localTime;
}
    void format(LogEvent event, scope size_t delegate(const(void)[]) dg)
{
const(char)[] level = event.levelName;
auto tm = event.time;
auto dt = localTime ? WallClock.toDate(tm) : Clock.toDate(tm);
char[20] tmp = void;
char[256] tmp2 = void;
dg(layout(tmp2,"%0-%1-%2 %3:%4:%5,%6 %7 [%8] - ",convert(tmp[0..4],dt.date.year),convert(tmp[4..6],dt.date.month),convert(tmp[6..8],dt.date.day),convert(tmp[8..10],dt.time.hours),convert(tmp[10..12],dt.time.minutes),convert(tmp[12..14],dt.time.seconds),convert(tmp[14..17],dt.time.millis),level,event.name));
dg(event.toString());
}
    private char[] convert(char[] tmp, long i)
{
return Integer.formatter(tmp,i,'u','?',8);
}

}

