// D import file generated from 'tango/core/ArrayLiteral.d'
module tango.core.ArrayLiteral;
import tango.core.Traits;
template ArrayLiteral(ElemTypes...)
{
auto ArrayLiteral(ElemTypes elems)
{
alias CommonType!(ElemTypes) ElemT;
ElemT[ElemTypes.length] ret;
foreach (idx, elem; elems)
{
alias ElemTypes[idx] OtherElemT;
static assert(!isStaticArrayType!(OtherElemT),"Element can't be a static array. Slice it first.");
static assert(is(OtherElemT : ElemT),"Incompatible types: " ~ ElemT.stringof ~ " and " ~ OtherElemT.stringof ~ ".");
ret[idx] = elem;
}
return ret;
}
}
private template CommonType(ElemTypes...)
{
static if(ElemTypes.length > 1)
{
    alias typeof(true ? ElemTypes[0] : CommonType!(ElemTypes[1 .. __dollar])) CommonType;
}
else
{
    static if(ElemTypes.length == 1)
{
    alias ElemTypes[0] CommonType;
}
else
{
    alias void CommonType;
}
}
}

debug (UnitTest)
{
    }
