// D import file generated from 'tango/core/Tuple.d'
module tango.core.Tuple;
template Tuple(TList...)
{
alias TList Tuple;
}
template IndexOf(T,TList...)
{
static if(TList.length == 0)
{
    const size_t IndexOf = 0;

}
else
{
    static if(is(T == TList[0]))
{
    const size_t IndexOf = 0;

}
else
{
    const size_t IndexOf = 1 + IndexOf!(T,TList[1 .. __dollar]);

}
}
}
template Remove(T,TList...)
{
static if(TList.length == 0)
{
    alias TList Remove;
}
else
{
    static if(is(T == TList[0]))
{
    alias TList[1 .. __dollar] Remove;
}
else
{
    alias Tuple!(TList[0],Remove!(T,TList[1 .. __dollar])) Remove;
}
}
}
template RemoveAll(T,TList...)
{
static if(TList.length == 0)
{
    alias TList RemoveAll;
}
else
{
    static if(is(T == TList[0]))
{
    alias .RemoveAll!(T,TList[1 .. __dollar]) RemoveAll;
}
else
{
    alias Tuple!(TList[0],.RemoveAll!(T,TList[1 .. __dollar])) RemoveAll;
}
}
}
template Replace(T,U,TList...)
{
static if(TList.length == 0)
{
    alias TList Replace;
}
else
{
    static if(is(T == TList[0]))
{
    alias Tuple!(U,TList[1 .. __dollar]) Replace;
}
else
{
    alias Tuple!(TList[0],Replace!(T,U,TList[1 .. __dollar])) Replace;
}
}
}
template ReplaceAll(T,U,TList...)
{
static if(TList.length == 0)
{
    alias TList ReplaceAll;
}
else
{
    static if(is(T == TList[0]))
{
    alias Tuple!(U,ReplaceAll!(T,U,TList[1 .. __dollar])) ReplaceAll;
}
else
{
    alias Tuple!(TList[0],ReplaceAll!(T,U,TList[1 .. __dollar])) ReplaceAll;
}
}
}
template Reverse(TList...)
{
static if(TList.length == 0)
{
    alias TList Reverse;
}
else
{
    alias Tuple!(Reverse!(TList[1 .. __dollar]),TList[0]) Reverse;
}
}
template Unique(TList...)
{
static if(TList.length == 0)
{
    alias TList Unique;
}
else
{
    alias Tuple!(TList[0],Unique!(RemoveAll!(TList[0],TList[1 .. __dollar]))) Unique;
}
}
template MostDerived(T,TList...)
{
static if(TList.length == 0)
{
    alias T MostDerived;
}
else
{
    static if(is(TList[0] : T))
{
    alias MostDerived!(TList[0],TList[1 .. __dollar]) MostDerived;
}
else
{
    alias MostDerived!(T,TList[1 .. __dollar]) MostDerived;
}
}
}
template DerivedToFront(TList...)
{
static if(TList.length == 0)
{
    alias TList DerivedToFront;
}
else
{
    alias Tuple!(MostDerived!(TList[0],TList[1 .. __dollar]),DerivedToFront!(ReplaceAll!(MostDerived!(TList[0],TList[1 .. __dollar]),TList[0],TList[1 .. __dollar]))) DerivedToFront;
}
}
static assert(0 == IndexOf!(int,int,float,char));
static assert(1 == IndexOf!(float,int,float,char));
static assert(3 == IndexOf!(double,int,float,char));
static assert(is(Remove!(int,int,float,int) == Remove!(void,float,int)));
static assert(is(RemoveAll!(int,int,float,int) == Remove!(void,float)));
static assert(is(Remove!(float,int,float,int) == Remove!(void,int,int)));
static assert(is(Remove!(double,int,float,int) == Remove!(void,int,float,int)));
static assert(is(Replace!(int,char,int,float,int) == Remove!(void,char,float,int)));
static assert(is(ReplaceAll!(int,char,int,float,int) == Remove!(void,char,float,char)));
static assert(is(Replace!(float,char,int,float,int) == Remove!(void,int,char,int)));
static assert(is(Replace!(double,char,int,float,int) == Remove!(void,int,float,int)));
static assert(is(Reverse!(float,float[],double,char,int) == Unique!(int,char,double,float[],char,int,float,double)));
static assert(is(MostDerived!(int,long,short) == short));
