// D import file generated from 'tango/core/sync/Barrier.d'
module tango.core.sync.Barrier;
public import tango.core.Exception;

private import tango.core.sync.Condition;

private import tango.core.sync.Mutex;

version (Win32)
{
    private import tango.sys.win32.UserGdi;

}
else
{
    version (Posix)
{
    private import tango.stdc.errno;

    private import tango.stdc.posix.pthread;

}
}
class Barrier
{
    this(uint limit)
in
{
assert(limit > 0);
}
body
{
m_lock = new Mutex;
m_cond = new Condition(m_lock);
m_group = 0;
m_limit = limit;
m_count = limit;
}
    void wait();
    private 
{
    Mutex m_lock;
    Condition m_cond;
    uint m_group;
    uint m_limit;
    uint m_count;
}
}
debug (UnitTest)
{
    private import tango.core.Thread;

    }
