// D import file generated from 'tango/core/sync/Mutex.d'
module tango.core.sync.Mutex;
public import tango.core.Exception;

version (Win32)
{
    private import tango.sys.win32.UserGdi;

}
else
{
    version (Posix)
{
    private import tango.stdc.posix.pthread;

}
}
class Mutex : Object.Monitor
{
    this();
    this(Object o)
in
{
assert((cast(void**)o)[1] is null);
}
body
{
this();
(cast(void**)o)[1] = &m_proxy;
}
    ~this();
    void lock();
    void unlock();
    bool tryLock();
    version (Posix)
{
    shared static this();
    }
    private 
{
    version (Win32)
{
    CRITICAL_SECTION m_hndl;
}
else
{
    version (Posix)
{
    static __gshared pthread_mutexattr_t sm_attr;

    pthread_mutex_t m_hndl;
}
}
    struct MonitorProxy
{
    Object.Monitor link;
}
    MonitorProxy m_proxy;
    package version (Posix)
{
    pthread_mutex_t* handleAddr()
{
return &m_hndl;
}
}

}
}
debug (UnitTest)
{
    private import tango.core.Thread;

    }
