// D import file generated from 'tango/core/tools/FrameInfo.d'
module tango.core.tools.FrameInfo;
version (D_Version2)
{
    package 
{
    struct FrameInfo
{
    long line;
    size_t iframe;
    ptrdiff_t offsetSymb;
    size_t baseSymb;
    ptrdiff_t offsetImg;
    size_t baseImg;
    size_t address;
    const(char)[] file;
    char[] func;
    const(char)[] extra;
    bool exactAddress;
    bool internalFunction;
    alias void function(FrameInfo*, void delegate(in char[])) FramePrintHandler;
    static FramePrintHandler defaultFramePrintingFunction;

    void writeOut(void delegate(in char[]) sink)
{
if (defaultFramePrintingFunction)
{
defaultFramePrintingFunction(&this,sink);
}
else
{
char[26] buf;
if (func.length)
{
sink(func);
}
else
{
sink("???");
}
{
for (size_t i = func.length;
 i < 80; ++i)
{
sink(" ");
}
}
if (extra.length)
{
sink(extra);
sink(" ");
}
sink(file);
sink(":");
sink(ulongToUtf8(buf,line));
}
}
    void clear()
{
line = 0;
iframe = -1;
offsetImg = 0;
baseImg = 0;
offsetSymb = 0;
baseSymb = 0;
address = 0;
exactAddress = true;
internalFunction = false;
file = null;
func = null;
extra = null;
}
}
    const(char)[] ulongToUtf8(char[] tmp, ulong val);
}
}
