// D import file generated from 'tango/core/tools/LinuxStackTrace.d'
module tango.core.tools.LinuxStackTrace;
import tango.core.tools.FrameInfo;
version (TangoDoc)
{
}
else
{
    version (D_Version2)
{
    private void ThWriteOut(Throwable th, void delegate(in char[]) sink);

}
    version (linux)
{
    import tango.stdc.stdlib;
    import tango.stdc.stdio;
    import tango.stdc.string;
    import tango.stdc.stringz;
    import tango.stdc.signal;
    import tango.stdc.errno;
    import tango.stdc.posix.unistd;
    import tango.text.Util;
    import tango.core.Array;
    import tango.core.Runtime;
    class SymbolException : Exception
{
    this(immutable(char)[] msg, immutable(char)[] file, long lineNr, Exception next = null)
{
super(msg,file,cast(uint)lineNr,next);
}
}
    bool may_read(size_t addr)
{
errno(0);
access(cast(char*)addr,0);
return errno() != EFAULT;
}
    private extern (C) 
{
    alias ushort Elf32_Half;
    alias ushort Elf64_Half;
    alias uint Elf32_Word;
    alias int Elf32_Sword;
    alias uint Elf64_Word;
    alias int Elf64_Sword;
    alias ulong Elf32_Xword;
    alias long Elf32_Sxword;
    alias ulong Elf64_Xword;
    alias long Elf64_Sxword;
    alias uint Elf32_Addr;
    alias ulong Elf64_Addr;
    alias uint Elf32_Off;
    alias ulong Elf64_Off;
    alias ushort Elf32_Section;
    alias ushort Elf64_Section;
    alias Elf32_Half Elf32_Versym;
    alias Elf64_Half Elf64_Versym;
    struct Elf32_Sym
{
    Elf32_Word st_name;
    Elf32_Addr st_value;
    Elf32_Word st_size;
    ubyte st_info;
    ubyte st_other;
    Elf32_Section st_shndx;
}
    struct Elf64_Sym
{
    Elf64_Word st_name;
    ubyte st_info;
    ubyte st_other;
    Elf64_Section st_shndx;
    Elf64_Addr st_value;
    Elf64_Xword st_size;
}
    struct Elf32_Phdr
{
    Elf32_Word p_type;
    Elf32_Off p_offset;
    Elf32_Addr p_vaddr;
    Elf32_Addr p_paddr;
    Elf32_Word p_filesz;
    Elf32_Word p_memsz;
    Elf32_Word p_flags;
    Elf32_Word p_align;
}
    struct Elf64_Phdr
{
    Elf64_Word p_type;
    Elf64_Word p_flags;
    Elf64_Off p_offset;
    Elf64_Addr p_vaddr;
    Elf64_Addr p_paddr;
    Elf64_Xword p_filesz;
    Elf64_Xword p_memsz;
    Elf64_Xword p_align;
}
    struct Elf32_Dyn
{
    Elf32_Sword d_tag;
    union
{
Elf32_Word d_val;
Elf32_Addr d_ptr;
}
}
    struct Elf64_Dyn
{
    Elf64_Sxword d_tag;
    union
{
Elf64_Xword d_val;
Elf64_Addr d_ptr;
}
}
    enum 
{
EI_NIDENT = 16,
}
    struct Elf32_Ehdr
{
    char[EI_NIDENT] e_ident;
    Elf32_Half e_type;
    Elf32_Half e_machine;
    Elf32_Word e_version;
    Elf32_Addr e_entry;
    Elf32_Off e_phoff;
    Elf32_Off e_shoff;
    Elf32_Word e_flags;
    Elf32_Half e_ehsize;
    Elf32_Half e_phentsize;
    Elf32_Half e_phnum;
    Elf32_Half e_shentsize;
    Elf32_Half e_shnum;
    Elf32_Half e_shstrndx;
}
    struct Elf64_Ehdr
{
    char[EI_NIDENT] e_ident;
    Elf64_Half e_type;
    Elf64_Half e_machine;
    Elf64_Word e_version;
    Elf64_Addr e_entry;
    Elf64_Off e_phoff;
    Elf64_Off e_shoff;
    Elf64_Word e_flags;
    Elf64_Half e_ehsize;
    Elf64_Half e_phentsize;
    Elf64_Half e_phnum;
    Elf64_Half e_shentsize;
    Elf64_Half e_shnum;
    Elf64_Half e_shstrndx;
}
    struct Elf32_Shdr
{
    Elf32_Word sh_name;
    Elf32_Word sh_type;
    Elf32_Word sh_flags;
    Elf32_Addr sh_addr;
    Elf32_Off sh_offset;
    Elf32_Word sh_size;
    Elf32_Word sh_link;
    Elf32_Word sh_info;
    Elf32_Word sh_addralign;
    Elf32_Word sh_entsize;
}
    struct Elf64_Shdr
{
    Elf64_Word sh_name;
    Elf64_Word sh_type;
    Elf64_Xword sh_flags;
    Elf64_Addr sh_addr;
    Elf64_Off sh_offset;
    Elf64_Xword sh_size;
    Elf64_Word sh_link;
    Elf64_Word sh_info;
    Elf64_Xword sh_addralign;
    Elf64_Xword sh_entsize;
}
    enum 
{
PT_DYNAMIC = 2,
DT_STRTAB = 5,
DT_SYMTAB = 6,
DT_STRSZ = 10,
DT_DEBUG = 21,
SHT_SYMTAB = 2,
SHT_STRTAB = 3,
STB_LOCAL = 0,
}
}

    ubyte ELF32_ST_BIND(ulong info)
{
return cast(ubyte)((info & 240) >> 4);
}
    static if(4 == (void*).sizeof)
{
    alias Elf32_Sym Elf_Sym;
    alias Elf32_Dyn Elf_Dyn;
    alias Elf32_Addr Elf_Addr;
    alias Elf32_Phdr Elf_Phdr;
    alias Elf32_Half Elf_Half;
    alias Elf32_Ehdr Elf_Ehdr;
    alias Elf32_Shdr Elf_Shdr;
}
else
{
    static if(8 == (void*).sizeof)
{
    alias Elf64_Sym Elf_Sym;
    alias Elf64_Dyn Elf_Dyn;
    alias Elf64_Addr Elf_Addr;
    alias Elf64_Phdr Elf_Phdr;
    alias Elf64_Half Elf_Half;
    alias Elf64_Ehdr Elf_Ehdr;
    alias Elf64_Shdr Elf_Shdr;
}
else
{
    static assert(0);
}
}
    struct StaticSectionInfo
{
    Elf_Ehdr header;
    const(char)[] stringTable;
    Elf_Sym[] sym;
    ubyte[] debugLine;
    const(char)[] fileName;
    void* mmapBase;
    size_t mmapLen;
    static StaticSectionInfo opCall(Elf_Ehdr header, const(char)[] stringTable, Elf_Sym[] sym, ubyte[] debugLine, const(char)[] fileName, void* mmapBase = null, size_t mmapLen = 0)
{
StaticSectionInfo newV;
newV.header = header;
newV.stringTable = stringTable;
newV.sym = sym;
newV.debugLine = debugLine;
newV.fileName = fileName;
newV.mmapBase = mmapBase;
newV.mmapLen = mmapLen;
return newV;
}

    const MAX_SECTS = 5;
    static StaticSectionInfo[MAX_SECTS] _gSections;

    static 
{
    size_t _nGSections;
    size_t _nFileBuf;
}
    static char[MAX_SECTS * 256] _fileNameBuf;

    static int opApply(scope int delegate(ref StaticSectionInfo) loop)
{
{
for (size_t i = 0;
 i < _nGSections; ++i)
{
{
auto res = loop(_gSections[i]);
if (res)
return res;
}
}
}
return 0;
}

    static int opApply(scope int delegate(ref const(char)[] sNameP, ref size_t startAddr, ref size_t endAddr, ref bool pub) loop);

    static StaticSectionInfo* addGSection(Elf_Ehdr header, const(char)[] stringTable, Elf_Sym[] sym, ubyte[] debugLine, const(char)[] fileName, void* mmapBase = null, size_t mmapLen = 0);

    static void resolveLineNumber(ref FrameInfo info);

}
    private void scan_static(in char* file);

    private void find_symbols()
{
find_static();
}

    private void find_static();

    shared static this();
    private void dwarf_error(const(char)[] msg)
{
Runtime.console.stderr("Tango stacktracer DWARF error: ");
Runtime.console.stderr(msg);
Runtime.console.stderr("\x0a");
}

    alias short uhalf;
    struct DwarfReader
{
    ubyte[] data;
    size_t read_pos;
    bool is_dwarf_64;
    @property size_t left()
{
return data.length - read_pos;
}

    @property ubyte next()
{
ubyte r = data[read_pos];
read_pos++;
return r;
}

    size_t read_initial_length();
    private ulong do_read_leb(bool sign_ext);

    ulong uleb128()
{
return do_read_leb(false);
}
    long sleb128()
{
return do_read_leb(true);
}
    template read(T)
{
T read()
{
T r = *cast(T*)data[read_pos..read_pos + T.sizeof].ptr;
read_pos += T.sizeof;
return r;
}
}
    size_t read_header_length()
{
if (is_dwarf_64)
{
return cast(size_t)read!(ulong)();
}
else
{
return cast(size_t)read!(uint)();
}
}
    const(char)[] str()
{
char* start = cast(char*)&data[read_pos];
size_t len = strlen(start);
read_pos += len + 1;
return start[0..len];
}
}
        bool find_line_number(ubyte[] debug_line, size_t address, bool is_return_address, ref const(char)[] out_directory, ref const(char)[] out_file, ref long out_line);
}
}
