// D import file generated from 'tango/io/model/IFile.d'
module tango.io.model.IFile;
interface FileConst
{
    version (Win32)
{
    enum : char
{
CurrentDirChar = '.',
FileSeparatorChar = '.',
PathSeparatorChar = '/',
SystemPathChar = ';',
}
    enum immutable(char)[] ParentDirString = "..";
    enum immutable(char)[] CurrentDirString = ".";
    enum immutable(char)[] FileSeparatorString = ".";
    enum immutable(char)[] PathSeparatorString = "/";
    enum immutable(char)[] SystemPathString = ";";
    enum immutable(char)[] NewlineString = "\x0d\x0a";
}
    version (Posix)
{
    enum : char
{
CurrentDirChar = '.',
FileSeparatorChar = '.',
PathSeparatorChar = '/',
SystemPathChar = ':',
}
    enum immutable(char)[] ParentDirString = "..";
    enum immutable(char)[] CurrentDirString = ".";
    enum immutable(char)[] FileSeparatorString = ".";
    enum immutable(char)[] PathSeparatorString = "/";
    enum immutable(char)[] SystemPathString = ":";
    enum immutable(char)[] NewlineString = "\x0a";
}
}
struct FileInfo
{
    const(char)[] path;
    const(char)[] name;
    ulong bytes;
    bool folder;
    bool hidden;
    bool system;
}
