// D import file generated from 'tango/io/stream/Delimiters.d'
module tango.io.stream.Delimiters;
private import tango.io.stream.Iterator;

template Delimiters(T)
{
class Delimiters : Iterator!(T)
{
    private const(T)[] delim;

    this(const(T)[] delim, InputStream stream = null)
{
this.delim = delim;
super(stream);
}
    protected override size_t scan(const(void)[] data)
{
auto content = (cast(const(T)*)data.ptr)[0..data.length / T.sizeof];
if (delim.length is 1)
{
foreach (int i, T c; content)
{
if (c is delim[0])
return found(set(content.ptr,0,i,i));
}
}
else
foreach (int i, T c; content)
{
if (has(delim,c))
return found(set(content.ptr,0,i,i));
}
return notFound();
}


}
}
debug (UnitTest)
{
    private import tango.io.device.Array;

    }
