// D import file generated from 'tango/io/stream/Lines.d'
module tango.io.stream.Lines;
private import tango.io.stream.Iterator;

template Lines(T)
{
class Lines : Iterator!(T)
{
    this(InputStream stream = null)
{
super(stream);
}
    final bool readln(ref const(T)[] content)
{
content = super.next;
return content.ptr !is null;
}

    protected override size_t scan(const(void)[] data)
{
auto content = (cast(const(T)*)data.ptr)[0..data.length / T.sizeof];
foreach (int i, T c; content)
{
if (c is '\x0a')
{
int slice = i;
if (i && content[i - 1] is '\x0d')
--slice;
set(content.ptr,0,slice,i);
return found(i);
}
}
return notFound();
}


}
}
debug (UnitTest)
{
    private import tango.io.device.Array;

    }
debug (Lines)
{
    import tango.io.Console;
    import tango.io.device.Array;
    void main();
}
