// D import file generated from 'tango/io/stream/Typed.d'
module tango.io.stream.Typed;
private import tango.io.device.Conduit;

private import tango.io.stream.Buffered;

template TypedInput(T)
{
class TypedInput : InputFilter
{
    this(InputStream stream)
{
super(BufferedInput.create(stream));
}
    final override TypedInput flush()
{
super.flush();
return this;
}

    final bool read(ref T x)
{
return source.read((&x)[0..1]) is T.sizeof;
}

    final int opApply(scope int delegate(ref T x) dg)
{
T x;
int ret;
while (source.read((&x)[0..1]) is T.sizeof)
if ((ret = dg(x)) != 0)
break;
return ret;
}

}
}
template TypedOutput(T)
{
class TypedOutput : OutputFilter
{
    this(OutputStream stream)
{
super(BufferedOutput.create(stream));
}
    final void write(ref T x)
{
sink.write((&x)[0..1]);
}

}
}
debug (UnitTest)
{
    import tango.io.Stdout;
    import tango.io.stream.Utf;
    import tango.io.device.Array;
    }
