// D import file generated from 'tango/net/device/Datagram.d'
module tango.net.device.Datagram;
package import tango.net.device.Socket;

class Datagram : Socket
{
    this()
{
super(AddressFamily.INET,SocketType.DGRAM,ProtocolType.IP);
}
    override size_t read(void[] src)
{
return read(src,null);
}

    size_t read(void[] dst, Address from)
{
size_t count;
if (dst.length)
{
count = from ? native.receiveFrom(dst,from) : native.receiveFrom(dst);
if (count <= 0)
count = Eof;
}
return count;
}
    override size_t write(const(void)[] src)
{
return write(src,null);
}

    size_t write(const(void)[] src, Address to)
{
int count = Eof;
if (src.length)
{
count = to ? native.sendTo(src,to) : native.sendTo(src);
if (count <= 0)
count = Eof;
}
return count;
}
}
debug (Datagram)
{
    import tango.io.Console;
    import tango.net.InternetAddress;
    void main()
{
auto addr = new InternetAddress("127.0.0.1",8080);
auto gram = new Datagram;
gram.bind(addr);
gram.write("hello",addr);
char[8] tmp;
auto x = new InternetAddress;
auto bytes = gram.read(tmp,x);
Cout(x)(tmp[0..bytes]).newline;
}
}
