// D import file generated from 'tango/stdc/posix/netinet/in_.d'
module tango.stdc.posix.netinet.in_;
private import tango.stdc.posix.config;

public import tango.stdc.inttypes;

public import tango.stdc.posix.arpa.inet;

public import tango.stdc.posix.sys.socket;

extern (C) 
{
    version (linux)
{
    private const __SOCK_SIZE__ = 16;

    struct sockaddr_in
{
    sa_family_t sin_family;
    in_port_t sin_port;
    in_addr sin_addr;
    ubyte[__SOCK_SIZE__ - sa_family_t.sizeof - in_port_t.sizeof - in_addr.sizeof] __pad;
}
    enum 
{
IPPROTO_IP = 0,
IPPROTO_ICMP = 1,
IPPROTO_TCP = 6,
IPPROTO_UDP = 17,
}
    const uint INADDR_ANY = 0;

    const uint INADDR_BROADCAST = -1u;

}
else
{
    version (darwin)
{
    private const __SOCK_SIZE__ = 16;

    struct sockaddr_in
{
    ubyte sin_len;
    sa_family_t sin_family;
    in_port_t sin_port;
    in_addr sin_addr;
    ubyte[8] sin_zero;
}
    enum 
{
IPPROTO_IP = 0,
IPPROTO_ICMP = 1,
IPPROTO_TCP = 6,
IPPROTO_UDP = 17,
}
    const uint INADDR_ANY = 0;

    const uint INADDR_BROADCAST = -1u;

}
else
{
    version (freebsd)
{
    private const __SOCK_SIZE__ = 16;

    struct sockaddr_in
{
    ubyte sin_len;
    sa_family_t sin_family;
    in_port_t sin_port;
    in_addr sin_addr;
    ubyte[8] sin_zero;
}
    enum 
{
IPPROTO_IP = 0,
IPPROTO_ICMP = 1,
IPPROTO_TCP = 6,
IPPROTO_UDP = 17,
}
    const uint INADDR_ANY = 0;

    const uint INADDR_BROADCAST = -1u;

}
else
{
    version (solaris)
{
    struct sockaddr_in
{
    sa_family_t sin_family;
    in_port_t sin_port;
    in_addr sin_addr;
    ubyte[8] sin_zero;
}
    enum 
{
IPPROTO_IP = 0,
IPPROTO_ICMP = 1,
IPPROTO_TCP = 6,
IPPROTO_UDP = 17,
}
    const uint INADDR_ANY = 0;

    const uint INADDR_BROADCAST = -1u;

}
}
}
}
    version (linux)
{
    struct in6_addr
{
    union
{
uint8_t[16] s6_addr;
uint16_t[8] s6_addr16;
uint32_t[4] s6_addr32;
}
}
    struct sockaddr_in6
{
    sa_family_t sin6_family;
    in_port_t sin6_port;
    uint32_t sin6_flowinfo;
    in6_addr sin6_addr;
    uint32_t sin6_scope_id;
}
    extern in6_addr in6addr_any;

    extern in6_addr in6addr_loopback;

    struct ipv6_mreq
{
    in6_addr ipv6mr_multiaddr;
    uint ipv6mr_interface;
}
    enum : uint
{
IPPROTO_IPV6 = 41,
INET6_ADDRSTRLEN = 46,
IPV6_JOIN_GROUP = 20,
IPV6_LEAVE_GROUP = 21,
IPV6_MULTICAST_HOPS = 18,
IPV6_MULTICAST_IF = 17,
IPV6_MULTICAST_LOOP = 19,
IPV6_UNICAST_HOPS = 16,
IPV6_V6ONLY = 26,
}
    extern (D) int IN6_IS_ADDR_UNSPECIFIED(in6_addr* addr)
{
return (cast(uint32_t*)addr)[0] == 0 && (cast(uint32_t*)addr)[1] == 0 && (cast(uint32_t*)addr)[2] == 0 && (cast(uint32_t*)addr)[3] == 0;
}

    extern (D) int IN6_IS_ADDR_LOOPBACK(in6_addr* addr)
{
return (cast(uint32_t*)addr)[0] == 0 && (cast(uint32_t*)addr)[1] == 0 && (cast(uint32_t*)addr)[2] == 0 && (cast(uint32_t*)addr)[3] == htonl(1);
}

    extern (D) int IN6_IS_ADDR_MULTICAST(in6_addr* addr)
{
return (cast(uint8_t*)addr)[0] == 255;
}

    extern (D) int IN6_IS_ADDR_LINKLOCAL(in6_addr* addr)
{
return ((cast(uint32_t*)addr)[0] & htonl(-4194304u)) == htonl(-25165824u);
}

    extern (D) int IN6_IS_ADDR_SITELOCAL(in6_addr* addr)
{
return ((cast(uint32_t*)addr)[0] & htonl(-4194304u)) == htonl(-20971520u);
}

    extern (D) int IN6_IS_ADDR_V4MAPPED(in6_addr* addr)
{
return (cast(uint32_t*)addr)[0] == 0 && (cast(uint32_t*)addr)[1] == 0 && (cast(uint32_t*)addr)[2] == htonl(65535);
}

    extern (D) int IN6_IS_ADDR_V4COMPAT(in6_addr* addr)
{
return (cast(uint32_t*)addr)[0] == 0 && (cast(uint32_t*)addr)[1] == 0 && (cast(uint32_t*)addr)[2] == 0 && ntohl((cast(uint32_t*)addr)[3]) > 1;
}

    extern (D) int IN6_IS_ADDR_MC_NODELOCAL(in6_addr* addr)
{
return IN6_IS_ADDR_MULTICAST(addr) && ((cast(uint8_t*)addr)[1] & 15) == 1;
}

    extern (D) int IN6_IS_ADDR_MC_LINKLOCAL(in6_addr* addr)
{
return IN6_IS_ADDR_MULTICAST(addr) && ((cast(uint8_t*)addr)[1] & 15) == 2;
}

    extern (D) int IN6_IS_ADDR_MC_SITELOCAL(in6_addr* addr)
{
return IN6_IS_ADDR_MULTICAST(addr) && ((cast(uint8_t*)addr)[1] & 15) == 5;
}

    extern (D) int IN6_IS_ADDR_MC_ORGLOCAL(in6_addr* addr)
{
return IN6_IS_ADDR_MULTICAST(addr) && ((cast(uint8_t*)addr)[1] & 15) == 8;
}

    extern (D) int IN6_IS_ADDR_MC_GLOBAL(in6_addr* addr)
{
return IN6_IS_ADDR_MULTICAST(addr) && ((cast(uint8_t*)addr)[1] & 15) == 14;
}

}
    version (solaris)
{
    struct in6_addr
{
    union
{
uint8_t[16] s6_addr;
uint32_t[4] s6_addr32;
uint32_t __S6_align;
}
}
    struct sockaddr_in6
{
    sa_family_t sin6_family;
    in_port_t sin6_port;
    uint32_t sin6_flowinfo;
    in6_addr sin6_addr;
    uint32_t sin6_scope_id;
    uint32_t __sin6_src_id;
}
    extern in6_addr in6addr_any;

    extern in6_addr in6addr_loopback;

    struct ipv6_mreq
{
    in6_addr ipv6mr_multiaddr;
    uint ipv6mr_interface;
}
    enum : uint
{
IPPROTO_IPV6 = 41,
INET6_ADDRSTRLEN = 46,
IPV6_JOIN_GROUP = 9,
IPV6_LEAVE_GROUP = 10,
IPV6_MULTICAST_HOPS = 7,
IPV6_MULTICAST_IF = 6,
IPV6_MULTICAST_LOOP = 8,
IPV6_UNICAST_HOPS = 5,
IPV6_V6ONLY = 39,
}
    extern (D) int IN6_IS_ADDR_UNSPECIFIED(in6_addr* addr)
{
return addr.s6_addr32[3] == 0 && addr.s6_addr32[2] == 0 && addr.s6_addr32[1] == 0 && addr.s6_addr32[0] == 0;
}

    version (BigEndian)
{
    extern (D) int IN6_IS_ADDR_LOOPBACK(in6_addr* addr);

}
    extern (D) int IN6_IS_ADDR_MULTICAST(in6_addr* addr);

    extern (D) int IN6_IS_ADDR_LINKLOCAL(in6_addr* addr);

    extern (D) int IN6_IS_ADDR_SITELOCAL(in6_addr* addr);

    extern (D) int IN6_IS_ADDR_V4MAPPED(in6_addr* addr);

    extern (D) int IN6_IS_ADDR_V4COMPAT(in6_addr* addr);

    extern (D) int IN6_IS_ADDR_MC_NODELOCAL(in6_addr* addr);

    extern (D) int IN6_IS_ADDR_MC_LINKLOCAL(in6_addr* addr);

    extern (D) int IN6_IS_ADDR_MC_SITELOCAL(in6_addr* addr);

    extern (D) int IN6_IS_ADDR_MC_ORGLOCAL(in6_addr* addr);

    extern (D) int IN6_IS_ADDR_MC_GLOBAL(in6_addr* addr);

}
    version (linux)
{
    const uint IPPROTO_RAW = 255;

}
else
{
    version (solaris)
{
    const uint IPPROTO_RAW = 255;

}
}
}
