// D import file generated from 'tango/stdc/posix/pwd.d'
module tango.stdc.posix.pwd;
private import tango.stdc.posix.config;

public import tango.stdc.posix.sys.types;

extern (C) 
{
    version (linux)
{
    struct passwd
{
    char* pw_name;
    char* pw_passwd;
    uid_t pw_uid;
    gid_t pw_gid;
    char* pw_gecos;
    char* pw_dir;
    char* pw_shell;
}
}
else
{
    version (darwin)
{
    struct passwd
{
    char* pw_name;
    char* pw_passwd;
    uid_t pw_uid;
    gid_t pw_gid;
    time_t pw_change;
    char* pw_class;
    char* pw_gecos;
    char* pw_dir;
    char* pw_shell;
    time_t pw_expire;
}
}
else
{
    version (freebsd)
{
    struct passwd
{
    char* pw_name;
    char* pw_passwd;
    uid_t pw_uid;
    gid_t pw_gid;
    time_t pw_change;
    char* pw_class;
    char* pw_gecos;
    char* pw_dir;
    char* pw_shell;
    time_t pw_expire;
    int pw_fields;
}
}
else
{
    version (solaris)
{
    struct passwd
{
    char* pw_name;
    char* pw_passwd;
    uid_t pw_uid;
    gid_t pw_gid;
    char* pw_age;
    char* pw_comment;
    char* pw_gecos;
    char* pw_dir;
    char* pw_shell;
}
}
}
}
}
    passwd* getpwnam(in char*);
    passwd* getpwuid(uid_t);
    version (linux)
{
    int getpwnam_r(in char*, passwd*, char*, size_t, passwd**);
    int getpwuid_r(uid_t, passwd*, char*, size_t, passwd**);
}
else
{
    version (darwin)
{
    int getpwnam_r(in char*, passwd*, char*, size_t, passwd**);
    int getpwuid_r(uid_t, passwd*, char*, size_t, passwd**);
}
else
{
    version (freebsd)
{
    int getpwnam_r(in char*, passwd*, char*, size_t, passwd**);
    int getpwuid_r(uid_t, passwd*, char*, size_t, passwd**);
}
else
{
    version (solaris)
{
    int getpwnam_r(in char*, passwd*, char*, size_t, passwd**);
    int getpwuid_r(uid_t, passwd*, char*, size_t, passwd**);
}
}
}
}
    version (linux)
{
    void endpwent();
    passwd* getpwent();
    void setpwent();
}
else
{
    version (darwin)
{
    void endpwent();
    passwd* getpwent();
    void setpwent();
}
else
{
    version (freebsd)
{
    void endpwent();
    passwd* getpwent();
    void setpwent();
}
else
{
    version (solaris)
{
    void endpwent();
    passwd* getpwent();
    void setpwent();
}
}
}
}
}
