// D import file generated from 'tango/stdc/posix/sched.d'
module tango.stdc.posix.sched;
private import tango.stdc.posix.config;

public import tango.stdc.posix.time;

public import tango.stdc.posix.sys.types;

extern (C) 
{
    version (linux)
{
    struct sched_param
{
    int sched_priority;
}
    const SCHED_OTHER = 0;
    const SCHED_FIFO = 1;
    const SCHED_RR = 2;
}
else
{
    version (darwin)
{
    const SCHED_OTHER = 1;
    const SCHED_FIFO = 4;
    const SCHED_RR = 2;
    private const __SCHED_PARAM_SIZE__ = 4;

    struct sched_param
{
    int sched_priority;
    byte[__SCHED_PARAM_SIZE__] opaque;
}
}
else
{
    version (freebsd)
{
    struct sched_param
{
    int sched_priority;
}
    const SCHED_FIFO = 1;
    const SCHED_OTHER = 2;
    const SCHED_RR = 3;
}
else
{
    version (solaris)
{
    struct sched_param
{
    int sched_priority;
    int[8] sched_pad;
}
    const SCHED_FIFO = 1;
    const SCHED_OTHER = 0;
    const SCHED_RR = 2;
}
}
}
}
    int sched_getparam(pid_t, sched_param*);
    int sched_getscheduler(pid_t);
    int sched_setparam(pid_t, in sched_param*);
    int sched_setscheduler(pid_t, int, in sched_param*);
    version (linux)
{
    int sched_yield();
}
else
{
    version (darwin)
{
    int sched_yield();
}
else
{
    version (freebsd)
{
    int sched_yield();
}
else
{
    version (solaris)
{
    int sched_yield();
}
}
}
}
    version (linux)
{
    int sched_get_priority_max(int);
    int sched_get_priority_min(int);
    int sched_rr_get_interval(pid_t, timespec*);
}
else
{
    version (darwin)
{
    int sched_get_priority_min(int);
    int sched_get_priority_max(int);
}
else
{
    version (freebsd)
{
    int sched_get_priority_min(int);
    int sched_get_priority_max(int);
    int sched_rr_get_interval(pid_t, timespec*);
}
else
{
    version (solaris)
{
    int sched_get_priority_min(int);
    int sched_get_priority_max(int);
    int sched_rr_get_interval(pid_t, timespec*);
}
}
}
}
}
