// D import file generated from 'tango/stdc/posix/sys/ipc.d'
module tango.stdc.posix.sys.ipc;
private import tango.stdc.posix.config;

public import tango.stdc.posix.sys.types;

private import tango.core.Octal;

extern (C) version (linux)
{
    struct ipc_perm
{
    key_t __key;
    uid_t uid;
    gid_t gid;
    uid_t cuid;
    gid_t cgid;
    ushort mode;
    ushort __pad1;
    ushort __seq;
    ushort __pad2;
    c_ulong __unused1;
    c_ulong __unused2;
}
    const IPC_CREAT = octal!(1000);
    const IPC_EXCL = octal!(2000);
    const IPC_NOWAIT = octal!(4000);
    const key_t IPC_PRIVATE = 0;

    const IPC_RMID = 0;
    const IPC_SET = 1;
    const IPC_STAT = 2;
    key_t ftok(in char*, int);
}
else
{
    version (darwin)
{
}
else
{
    version (freebsd)
{
    struct ipc_perm
{
    ushort cuid;
    ushort cguid;
    ushort uid;
    ushort gid;
    ushort mode;
    ushort seq;
    key_t key;
}
    const IPC_CREAT = octal!(1000);
    const IPC_EXCL = octal!(2000);
    const IPC_NOWAIT = octal!(4000);
    const key_t IPC_PRIVATE = 0;

    const IPC_RMID = 0;
    const IPC_SET = 1;
    const IPC_STAT = 2;
    key_t ftok(in char*, int);
}
else
{
    version (solaris)
{
    struct ipc_perm
{
    uid_t uid;
    gid_t gid;
    uid_t cuid;
    gid_t cgid;
    mode_t mode;
    uint seq;
    key_t key;
    version (X86_64)
{
}
else
{
    version (X86)
{
    int[4] pad;
}
}
}
    const IPC_CREAT = octal!(1000);
    const IPC_EXCL = octal!(2000);
    const IPC_NOWAIT = octal!(4000);
    const key_t IPC_PRIVATE = 0;

    const IPC_RMID = 10;
    const IPC_SET = 11;
    const IPC_STAT = 12;
    key_t ftok(in char*, int);
}
}
}
}

