// D import file generated from 'tango/stdc/posix/sys/mman.d'
module tango.stdc.posix.sys.mman;
private import tango.stdc.posix.config;

public import tango.stdc.stddef;

public import tango.stdc.posix.sys.types;

extern (C) 
{
    version (linux)
{
    const POSIX_MADV_NORMAL = 0;
    const POSIX_MADV_RANDOM = 1;
    const POSIX_MADV_SEQUENTIAL = 2;
    const POSIX_MADV_WILLNEED = 3;
    const POSIX_MADV_DONTNEED = 4;
}
else
{
    version (darwin)
{
    const POSIX_MADV_NORMAL = 0;
    const POSIX_MADV_RANDOM = 1;
    const POSIX_MADV_SEQUENTIAL = 2;
    const POSIX_MADV_WILLNEED = 3;
    const POSIX_MADV_DONTNEED = 4;
}
else
{
    version (freebsd)
{
    const POSIX_MADV_NORMAL = 0;
    const POSIX_MADV_RANDOM = 1;
    const POSIX_MADV_SEQUENTIAL = 2;
    const POSIX_MADV_WILLNEED = 3;
    const POSIX_MADV_DONTNEED = 4;
}
else
{
    version (solaris)
{
    enum 
{
POSIX_MADV_NORMAL = 0,
POSIX_MADV_RANDOM = 1,
POSIX_MADV_SEQUENTIAL = 2,
POSIX_MADV_WILLNEED = 3,
POSIX_MADV_DONTNEED = 4,
}
}
}
}
}
    version (linux)
{
    const PROT_NONE = 0;
    const PROT_READ = 1;
    const PROT_WRITE = 2;
    const PROT_EXEC = 4;
}
else
{
    version (darwin)
{
    const PROT_NONE = 0;
    const PROT_READ = 1;
    const PROT_WRITE = 2;
    const PROT_EXEC = 4;
}
else
{
    version (freebsd)
{
    const PROT_NONE = 0;
    const PROT_READ = 1;
    const PROT_WRITE = 2;
    const PROT_EXEC = 4;
}
else
{
    version (solaris)
{
    enum 
{
PROT_NONE = 0,
PROT_READ = 1,
PROT_WRITE = 2,
PROT_EXEC = 4,
}
}
}
}
}
    version (linux)
{
    int munmap(void*, size_t);
    static if(__USE_LARGEFILE64)
{
    void* mmap64(void*, size_t, int, int, int, off_t);
    alias mmap64 mmap;
}
else
{
    void* mmap(void*, size_t, int, int, int, off_t);
}
}
else
{
    version (darwin)
{
    void* mmap(void*, size_t, int, int, int, off_t);
    int munmap(void*, size_t);
}
else
{
    version (freebsd)
{
    void* mmap(void*, size_t, int, int, int, off_t);
    int munmap(void*, size_t);
}
else
{
    version (solaris)
{
    int munmap(void*, size_t);
    version (X86_64)
{
    void* mmap(void*, size_t, int, int, int, off_t);
}
else
{
    static if(__USE_LARGEFILE64)
{
    void* mmap64(void*, size_t, int, int, int, off_t);
    alias mmap64 mmap;
}
else
{
    void* mmap(void*, size_t, int, int, int, off_t);
}
}
}
}
}
}
    version (linux)
{
    const MAP_SHARED = 1;
    const MAP_PRIVATE = 2;
    const MAP_FIXED = 16;
    const MAP_ANON = 32;
    const MAP_FAILED = cast(void*)-1;
    enum 
{
MS_ASYNC = 1,
MS_SYNC = 4,
MS_INVALIDATE = 2,
}
    int msync(void*, size_t, int);
}
else
{
    version (darwin)
{
    const MAP_SHARED = 1;
    const MAP_PRIVATE = 2;
    const MAP_FIXED = 16;
    const MAP_ANON = 4096;
    const MAP_FAILED = cast(void*)-1;
    const MS_ASYNC = 1;
    const MS_INVALIDATE = 2;
    const MS_SYNC = 16;
    int msync(void*, size_t, int);
}
else
{
    version (freebsd)
{
    const MAP_SHARED = 1;
    const MAP_PRIVATE = 2;
    const MAP_FIXED = 16;
    const MAP_ANON = 4096;
    const MAP_FAILED = cast(void*)-1;
    const MS_SYNC = 0;
    const MS_ASYNC = 1;
    const MS_INVALIDATE = 2;
    int msync(void*, size_t, int);
}
}
}
    version (solaris)
{
    const MAP_SHARED = 1;
    const MAP_PRIVATE = 2;
    const MAP_FIXED = 16;
    const MAP_ANON = 256;
    const MAP_FAILED = cast(void*)-1;
    enum 
{
MS_ASYNC = 1,
MS_SYNC = 4,
MS_INVALIDATE = 2,
}
    int msync(void*, size_t, int);
}
    version (linux)
{
    const MCL_CURRENT = 1;
    const MCL_FUTURE = 2;
    int mlockall(int);
    int munlockall();
}
else
{
    version (darwin)
{
    const MCL_CURRENT = 1;
    const MCL_FUTURE = 2;
    int mlockall(int);
    int munlockall();
}
else
{
    version (freebsd)
{
    const MCL_CURRENT = 1;
    const MCL_FUTURE = 2;
    int mlockall(int);
    int munlockall();
}
else
{
    version (solaris)
{
    const MCL_CURRENT = 1;
    const MCL_FUTURE = 2;
    int mlockall(int);
    int munlockall();
}
}
}
}
    version (linux)
{
    int mlock(in void*, size_t);
    int munlock(in void*, size_t);
}
else
{
    version (darwin)
{
    int mlock(in void*, size_t);
    int munlock(in void*, size_t);
}
else
{
    version (freebsd)
{
    int mlock(in void*, size_t);
    int munlock(in void*, size_t);
}
else
{
    version (solaris)
{
    int mlock(in void*, size_t);
    int munlock(in void*, size_t);
}
}
}
}
    version (linux)
{
    int mprotect(void*, size_t, int);
}
else
{
    version (darwin)
{
    int mprotect(void*, size_t, int);
}
else
{
    version (freebsd)
{
    int mprotect(void*, size_t, int);
}
else
{
    version (solaris)
{
    int mprotect(void*, size_t, int);
}
}
}
}
    version (linux)
{
    int shm_open(in char*, int, mode_t);
    int shm_unlink(in char*);
}
else
{
    version (darwin)
{
    int shm_open(in char*, int, mode_t);
    int shm_unlink(in char*);
}
else
{
    version (freebsd)
{
    int shm_open(in char*, int, mode_t);
    int shm_unlink(in char*);
}
else
{
    version (solaris)
{
    int shm_open(in char*, int, mode_t);
    int shm_unlink(in char*);
}
}
}
}
}
