// D import file generated from 'tango/stdc/posix/sys/wait.d'
module tango.stdc.posix.sys.wait;
private import tango.stdc.posix.config;

public import tango.stdc.posix.sys.types;

public import tango.stdc.posix.signal;

private import tango.core.Octal;

extern (C) 
{
    version (linux)
{
    const WNOHANG = 1;
    const WUNTRACED = 2;
    private 
{
    const __W_CONTINUED = 65535;
    extern (D) int __WTERMSIG(int status)
{
return status & 127;
}

}
    extern (D) int WEXITSTATUS(int status)
{
return (status & 65280) >> 8;
}

    extern (D) int WIFCONTINUED(int status)
{
return status == __W_CONTINUED;
}

    extern (D) bool WIFEXITED(int status)
{
return __WTERMSIG(status) == 0;
}

    extern (D) bool WIFSIGNALED(int status)
{
return cast(byte)((status & 127) + 1) >> 1 > 0;
}

    extern (D) bool WIFSTOPPED(int status)
{
return (status & 255) == 127;
}

    extern (D) int WSTOPSIG(int status)
{
return WEXITSTATUS(status);
}

    extern (D) int WTERMSIG(int status)
{
return status & 127;
}

}
else
{
    version (darwin)
{
    const WNOHANG = 1;
    const WUNTRACED = 2;
    private const _WSTOPPED = octal!(177);

    extern (D) int _WSTATUS(int status)
{
return status & octal!(177);
}

    extern (D) int WEXITSTATUS(int status)
{
return status >> 8;
}

    extern (D) int WIFCONTINUED(int status)
{
return status == 19;
}

    extern (D) bool WIFEXITED(int status)
{
return _WSTATUS(status) == 0;
}

    extern (D) bool WIFSIGNALED(int status)
{
return _WSTATUS(status) != _WSTOPPED && _WSTATUS(status) != 0;
}

    extern (D) bool WIFSTOPPED(int status)
{
return _WSTATUS(status) == _WSTOPPED;
}

    extern (D) int WSTOPSIG(int status)
{
return status >> 8;
}

    extern (D) int WTERMSIG(int status)
{
return _WSTATUS(status);
}

}
else
{
    version (freebsd)
{
    const WNOHANG = 1;
    const WUNTRACED = 2;
    const WCONTINUED = 4;
    private const _WSTOPPED = octal!(177);

    extern (D) int _WSTATUS(int status)
{
return status & octal!(177);
}

    extern (D) int WEXITSTATUS(int status)
{
return status >> 8;
}

    extern (D) int WIFCONTINUED(int status)
{
return status == 19;
}

    extern (D) bool WIFEXITED(int status)
{
return _WSTATUS(status) == 0;
}

    extern (D) bool WIFSIGNALED(int status)
{
return _WSTATUS(status) != _WSTOPPED && _WSTATUS(status) != 0;
}

    extern (D) bool WIFSTOPPED(int status)
{
return _WSTATUS(status) == _WSTOPPED;
}

    extern (D) int WSTOPSIG(int status)
{
return status >> 8;
}

    extern (D) int WTERMSIG(int status)
{
return _WSTATUS(status);
}

}
else
{
    version (solaris)
{
    const WCONTFLG = octal!(177777);
    const WNOHANG = octal!(100);
    const WUNTRACED = octal!(4);
    const WCONTINUED = octal!(10);
    extern (D) int WWORD(int status)
{
return status & octal!(177777);
}

    extern (D) int WEXITSTATUS(int status)
{
return status >> 8 & 255;
}

    extern (D) int WIFCONTINUED(int status)
{
return WWORD(status) == WCONTFLG;
}

    extern (D) bool WIFEXITED(int status)
{
return (status & 255) == 0;
}

    extern (D) bool WIFSIGNALED(int status)
{
return (status & 255) > 0 && (status & 65280) == 0;
}

    extern (D) bool WIFSTOPPED(int status)
{
return (status & 255) == octal!(177) && (status & 65280) != 0;
}

    extern (D) int WSTOPSIG(int status)
{
return status >> 8 & 255;
}

    extern (D) int WTERMSIG(int status)
{
return status & 127;
}

}
else
{
    static assert(false);
}
}
}
}
    pid_t wait(int*);
    pid_t waitpid(pid_t, int*, int);
}
