// D import file generated from 'tango/stdc/string.d'
module tango.stdc.string;
private import tango.stdc.stddef;

extern (C) 
{
    void* memchr(in void* s, int c, size_t n);
    int memcmp(in void* s1, in void* s2, size_t n);
    void* memcpy(void* s1, in void* s2, size_t n);
    void* memmove(void* s1, in void* s2, size_t n);
    void* memset(void* s, int c, size_t n);
    char* strcpy(char* s1, in char* s2);
    char* strncpy(char* s1, in char* s2, size_t n);
    char* strcat(char* s1, in char* s2);
    char* strncat(char* s1, in char* s2, size_t n);
    int strcmp(in char* s1, in char* s2);
    int strcoll(in char* s1, in char* s2);
    int strncmp(in char* s1, in char* s2, size_t n);
    size_t strxfrm(char* s1, in char* s2, size_t n);
    char* strchr(in char* s, int c);
    size_t strcspn(in char* s1, in char* s2);
    char* strpbrk(in char* s1, in char* s2);
    char* strrchr(in char* s, int c);
    size_t strspn(in char* s1, in char* s2);
    char* strstr(in char* s1, in char* s2);
    char* strtok(char* s1, in char* s2);
    char* strerror(int errnum);
    size_t strlen(in char* s);
    version (Posix)
{
    char* strdup(char*);
    char* strsignal(int sig);
}
    wchar_t* wmemchr(in wchar_t* s, wchar_t c, size_t n);
    int wmemcmp(in wchar_t* s1, in wchar_t* s2, size_t n);
    wchar_t* wmemcpy(wchar_t* s1, in wchar_t* s2, size_t n);
    wchar_t* wmemmove(wchar_t* s1, in wchar_t* s2, size_t n);
    wchar_t* wmemset(wchar_t* s, wchar_t c, size_t n);
    wchar_t* wcscpy(wchar_t* s1, in wchar_t* s2);
    wchar_t* wcsncpy(wchar_t* s1, in wchar_t* s2, size_t n);
    wchar_t* wcscat(wchar_t* s1, in wchar_t* s2);
    wchar_t* wcsncat(wchar_t* s1, in wchar_t* s2, size_t n);
    int wcscmp(in wchar_t* s1, in wchar_t* s2);
    int wcscoll(in wchar_t* s1, in wchar_t* s2);
    int wcsncmp(in wchar_t* s1, in wchar_t* s2, size_t n);
    size_t wcsxfrm(wchar_t* s1, in wchar_t* s2, size_t n);
    wchar_t* wcschr(in wchar_t* s, wchar_t c);
    size_t wcscspn(in wchar_t* s1, in wchar_t* s2);
    wchar_t* wcspbrk(in wchar_t* s1, in wchar_t* s2);
    wchar_t* wcsrchr(in wchar_t* s, wchar_t c);
    size_t wcsspn(in wchar_t* s1, in wchar_t* s2);
    wchar_t* wcsstr(in wchar_t* s1, in wchar_t* s2);
    wchar_t* wcstok(wchar_t* s1, in wchar_t* s2, wchar_t** ptr);
    size_t wcslen(wchar_t* s);
    alias int mbstate_t;
    wint_t btowc(int c);
    int wctob(wint_t c);
    int mbsinit(in mbstate_t* ps);
    size_t mbrlen(in char* s, size_t n, mbstate_t* ps);
    size_t mbrtowc(wchar_t* pwc, in char* s, size_t n, mbstate_t* ps);
    size_t wcrtomb(char* s, wchar_t wc, mbstate_t* ps);
    size_t mbsrtowcs(wchar_t* dst, in char** src, size_t len, mbstate_t* ps);
    size_t wcsrtombs(char* dst, in wchar_t** src, size_t len, mbstate_t* ps);
}
