// D import file generated from 'tango/sys/Common.d'
module tango.sys.Common;
version (Win32)
{
    public import tango.sys.win32.UserGdi;

}
version (linux)
{
    public import tango.sys.linux.linux;

    alias tango.sys.linux.linux posix;
}
version (darwin)
{
    public import tango.sys.darwin.darwin;

    alias tango.sys.darwin.darwin posix;
}
version (freebsd)
{
    public import tango.sys.freebsd.freebsd;

    alias tango.sys.freebsd.freebsd posix;
}
version (solaris)
{
    public import tango.sys.solaris.solaris;

    alias tango.sys.solaris.solaris posix;
}
version (Win32)
{
    private enum FORMAT_MESSAGE_ALLOCATE_BUFFER = 256;

    private enum FORMAT_MESSAGE_IGNORE_INSERTS = 512;

    private enum FORMAT_MESSAGE_FROM_STRING = 1024;

    private enum FORMAT_MESSAGE_FROM_HMODULE = 2048;

    private enum FORMAT_MESSAGE_FROM_SYSTEM = 4096;

    private enum FORMAT_MESSAGE_ARGUMENT_ARRAY = 8192;

    private enum FORMAT_MESSAGE_MAX_WIDTH_MASK = 255;

    private DWORD MAKELANGID(WORD p, WORD s)
{
return cast(WORD)s << 10 | cast(WORD)p;
}

    private alias HGLOBAL HLOCAL;

    private enum LANG_NEUTRAL = 0;

    private enum SUBLANG_DEFAULT = 1;

    private extern (Windows) 
{
    DWORD FormatMessageW(DWORD dwFlags, LPCVOID lpSource, DWORD dwMessageId, DWORD dwLanguageId, LPWSTR lpBuffer, DWORD nSize, LPCVOID args);
    HLOCAL LocalFree(HLOCAL hMem);
}

}
else
{
    version (Posix)
{
    private import tango.stdc.errno;

    private import tango.stdc.string;

}
else
{
    pragma (msg, "Unsupported environment; neither Win32 or Posix is declared");
    static assert(0);
}
}
struct SysError
{
    @property static uint lastCode();


    @property static char[] lastMsg()
{
return lookup(lastCode);
}


    @property static char[] lookup(uint errcode);


}
