// D import file generated from 'tango/sys/linux/inotify.d'
module tango.sys.linux.inotify;
version (linux)
{
    extern (C) 
{
    struct inotify_event
{
    int wd;
    uint mask;
    uint cookie;
    uint len;
}
    enum : uint
{
IN_ACCESS = 1,
IN_MODIFY = 2,
IN_ATTRIB = 4,
IN_CLOSE_WRITE = 8,
IN_CLOSE_NOWRITE = 16,
IN_CLOSE = 24,
IN_OPEN = 32,
IN_MOVED_FROM = 64,
IN_MOVED_TO = 128,
IN_MOVE = 192,
IN_CREATE = 256,
IN_DELETE = 512,
IN_DELETE_SELF = 1024,
IN_MOVE_SELF = 2048,
IN_UMOUNT = 8192,
IN_Q_OVERFLOW = 16384,
IN_IGNORED = 32768,
IN_ONLYDIR = 16777216,
IN_DONT_FOLLOW = 33554432,
IN_MASK_ADD = 536870912,
IN_ISDIR = 1073741824,
IN_ONESHOT = -2147483648u,
IN_ALL_EVENTS = 4095,
}
    int inotify_init();
    int inotify_add_watch(int fd, char* name, uint mask);
    int inotify_rm_watch(int fd, uint wd);
}
}
