// D import file generated from 'tango/text/Ascii.d'
module tango.text.Ascii;
version (Win32)
{
    private extern (C) int memicmp(in char*, in char*, uint);


    private extern (C) int memcmp(in char*, in char*, uint);


}
version (Posix)
{
    private extern (C) int memcmp(in char*, in char*, uint);


    private extern (C) int strncasecmp(in char*, in char*, uint);


    private alias strncasecmp memicmp;

}
char[] toLower(char[] src);
char[] toLower(const(char[]) src, char[] dst)
{
assert(dst.length >= src.length);
dst[0..src.length] = src[0..$];
return toLower(dst[0..src.length]);
}
char[] toUpper(char[] src);
char[] toUpper(const(char[]) src, char[] dst)
{
assert(dst.length >= src.length);
dst[0..src.length] = src[0..$];
return toUpper(dst[0..src.length]);
}
int icompare(const(char[]) s1, const(char[]) s2)
{
auto len = s1.length;
if (s2.length < len)
len = s2.length;
auto result = memicmp(s1.ptr,s2.ptr,cast(int)len);
if (result is 0)
result = cast(int)s1.length - cast(int)s2.length;
return result;
}
int compare(const(char[]) s1, const(char[]) s2)
{
auto len = s1.length;
if (s2.length < len)
len = s2.length;
auto result = memcmp(s1.ptr,s2.ptr,cast(int)len);
if (result is 0)
result = cast(int)s1.length - cast(int)s2.length;
return result;
}
size_t isearch(in char[] src, in char[] pattern);
debug (UnitTest)
{
    }
debug (Ascii)
{
    void main()
{
}
}
