// D import file generated from 'tango/text/locale/Locale.d'
module tango.text.locale.Locale;
private 
{
    import tango.text.locale.Core;
    import tango.text.locale.Convert;
}
private import tango.time.Time;

private import tango.text.convert.Layout;

public import tango.text.locale.Core;

public class Locale : Layout!(char)
{
    private DateTimeFormat dateFormat;

    private NumberFormat numberFormat;

    this(IFormatService formatService = null)
{
numberFormat = NumberFormat.getInstance(formatService);
dateFormat = DateTimeFormat.getInstance(formatService);
}
    protected override char[] unknown(char[] output, const(char)[] format, TypeInfo type, Arg p);


    protected override char[] integer(char[] output, long v, const(char)[] alt, ulong mask = (ulong).max, const(char)[] format = null)
{
return formatInteger(output,v,alt,numberFormat);
}


    protected override char[] floater(char[] output, real v, const(char)[] format)
{
return formatDouble(output,v,format,numberFormat);
}


}

debug (Locale)
{
    import tango.io.Console;
    import tango.time.WallClock;
    void main()
{
auto layout = new Locale(Culture.getCulture("fr-FR"));
Cout(layout("{:D}",WallClock.now))();
}
}
