// D import file generated from 'tango/util/container/more/Vector.d'
module tango.util.container.more.Vector;
private import tango.core.Exception;

private import tango.stdc.string;

template Vector(V,int Size = 0)
{
struct Vector
{
    alias add push;
    alias slice opSlice;
    template opOpAssign(immutable(char)[] s : "~")
{
Vector* opOpAssign(V value)
{
return push(value);
}
}
    static if(Size == 0)
{
    private size_t depth;

    private V[] vector;

}
else
{
    private size_t depth;

    private V[Size] vector;

}
    Vector* clear()
{
depth = 0;
return &this;
}
    const @property size_t size()
{
return depth;
}

    const size_t unused()
{
return vector.length - depth;
}

    Vector clone()
{
Vector v;
static if(Size == 0)
{
v.vector.length = vector.length;
}

v.vector[0..depth] = vector[0..depth];
v.depth = depth;
return v;
}
    V* add(V value)
{
static if(Size == 0)
{
if (depth >= vector.length)
vector.length = vector.length + 64;
vector[depth++] = value;
}
else
{
if (depth < vector.length)
vector[depth++] = value;
else
error(122);
}

return &vector[depth - 1];
}
    V* add()
{
static if(Size == 0)
{
if (depth >= vector.length)
vector.length = vector.length + 64;
}
else
{
if (depth >= vector.length)
error(144);
}

auto p = &vector[depth++];
*p = V.init;
return p;
}
    Vector* append(V[] value...)
{
foreach (v; value)
{
add(v);
}
return &this;
}
    V remove()
{
if (depth)
return vector[--depth];
return error(179);
}
    V remove(size_t i)
{
if (i < depth)
{
if (i is depth - 1)
return remove;
--depth;
auto v = vector[i];
memmove(vector.ptr + i,vector.ptr + i + 1,V.sizeof * (depth - i));
return v;
}
return error(203);
}
    V opIndex(size_t i)
{
if (i < depth)
return vector[i];
return error(219);
}
    V opIndexAssign(V value, size_t i)
{
if (i < depth)
{
vector[i] = value;
return value;
}
return error(238);
}
    V[] slice()
{
return vector[0..depth];
}
    private V error(size_t line)
{
throw new RangeError("tango/util/container/more/Vector.d",line);
}

    int opApply(scope int delegate(ref V value) dg)
{
int result;
{
for (int i = depth;
 i-- && result is 0;)
{
result = dg(vector[i]);
}
}
return result;
}
    int opApply(scope int delegate(ref V value, ref bool kill) dg)
{
int result;
{
for (int i = depth;
 i-- && result is 0;)
{
{
auto kill = false;
result = dg(vector[i],kill);
if (kill)
remove(i);
}
}
}
return result;
}
}
}
debug (Vector)
{
    import tango.io.Stdout;
    void main();
}
