// D import file generated from 'tango/util/digest/Crc32.d'
module tango.util.digest.Crc32;
public import tango.util.digest.Digest;

final class Crc32 : Digest
{
    private uint[256] table;

    private uint result = -1u;

    this(Crc32 crc32)
{
this.table[] = crc32.table[];
this.result = crc32.result;
}
    this(uint polynomial = -306674912u);
    override Crc32 update(const(void[]) input);

    override uint digestSize()
{
return 4;
}

    override ubyte[] binaryDigest(ubyte[] buf = null)
{
if (buf.length < 4)
buf.length = 4;
uint v = ~result;
buf[3] = cast(ubyte)(v >> 24);
buf[2] = cast(ubyte)(v >> 16);
buf[1] = cast(ubyte)(v >> 8);
buf[0] = cast(ubyte)v;
result = -1u;
return buf;
}

    uint crc32Digest()
{
uint ret = ~result;
result = -1u;
return ret;
}
}

debug (UnitTest)
{
    }
