// D import file generated from 'tango/util/log/LayoutChainsaw.d'
module tango.util.log.LayoutChainsaw;
private import tango.core.Thread;

private import tango.util.log.Log;

public class LayoutChainsaw : Appender.Layout
{
    void format(LogEvent event, scope size_t delegate(const(void)[]) dg)
{
char[20] tmp;
const(char)[] threadName;
threadName = Thread.getThis().name;
if (threadName.length is 0)
threadName = "{unknown}";
dg("<log4j:event logger=\"");
dg(event.name);
dg("\" timestamp=\"");
dg(event.toMilli(tmp,event.time.span));
dg("\" level=\"");
dg(event.levelName);
dg("\" thread=\"");
dg(threadName);
dg("\">\x0d\x0a<log4j:message><![CDATA[");
dg(event.toString());
dg("]]></log4j:message>\x0d\x0a<log4j:properties><log4j:data name=\"application\" value=\"");
dg(event.host.name);
dg("\"/><log4j:data name=\"hostname\" value=\"");
dg(event.host.address);
dg("\"/></log4j:properties></log4j:event>\x0d\x0a");
}
}

