// D import file generated from 'tango/util/log/model/ILogger.d'
module tango.util.log.model.ILogger;
interface ILogger
{
    enum Level 
{
Trace = 0,
Info,
Warn,
Error,
Fatal,
None,
}
    @property bool enabled(Level level = Level.Fatal);

    void trace(const(char[]) fmt,...);
    void info(const(char[]) fmt,...);
    void warn(const(char[]) fmt,...);
    void error(const(char[]) fmt,...);
    void fatal(const(char[]) fmt,...);
    @property const(char)[] name();

    @property Level level();

    @property ILogger level(Level l);

    @property bool additive();

    @property ILogger additive(bool enabled);

    ILogger append(Level level, lazy const(char[]) exp);
}
